/* Process model C form file: ip_output_iface_VC1.pr.c */
/* Portions of this file copyright 1992-2001 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char ip_output_iface_VC1_pr_c [] = "MIL_3_Tfile_Hdr_ 80C 30A opnet 7 3CB8E1C7 3CB8E1C7 1 luna nalborz 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                           ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

/***** Includes *****/
#include "ip_addr_v4.h" 
#include "ip_rte_v4.h"
#include "oms_bgutil.h"
#include "oms_qm.h"
#include "ip_qos_notif_log_support.h"
#include "rsvp.h"
#include <oms_pr.h>

/* Transitions to determine how this process	*/
/* got invoked.									*/
#define		LTRACE_RSVP					((op_prg_odb_ltrace_active ("ip_rsvp")) || (op_prg_odb_ltrace_active ("rsvp")) || (op_prg_odb_ltrace_active ("rsvp_resv")))
#define		RECEIVE_PACKET	 			((invocation_mode == OPC_PROINV_INDIRECT) && (rsvp_call_type == OPC_INT_INVALID))
#define		SEND_PACKET					((invocation_mode == OPC_PROINV_DIRECT) && (queue_to_be_deleted == OPC_FALSE))
#define		CREATE_RSVP_QUEUE			((invocation_mode == OPC_PROINV_INDIRECT) && (rsvp_call_type == RsvpC_TC_Add_Flowspec))
#define		MODIFY_RSVP_QUEUE_PARAMS	((invocation_mode == OPC_PROINV_INDIRECT) && (rsvp_call_type == RsvpC_TC_Mod_Flowspec))
#define		DELETE_RSVP_QUEUE			(((invocation_mode == OPC_PROINV_INDIRECT) && (rsvp_call_type == RsvpC_TC_Del_Flowspec)) || ((invocation_mode == OPC_PROINV_DIRECT) && (queue_to_be_deleted == OPC_TRUE)))
#define		ADD_RSVP_SENDER				((invocation_mode == OPC_PROINV_INDIRECT) && (rsvp_call_type == RsvpC_TC_Add_Filter))
#define		DELETE_RSVP_SENDER			((invocation_mode == OPC_PROINV_INDIRECT) && (rsvp_call_type == RsvpC_TC_Del_Filter))
#define		WFQ_PKT_TXTYPE_UCAST		1
#define		WFQ_PKT_TXTYPE_MCAST		2
#define		WFQ_PKT_TXTYPE_BCAST		3
#define		IP_DIM_STAT_INDEX_MAX		100
#define		IP_IFACE_INSUFF_WEIGHT		-1
#define		QUEUE_DELETED_BY_RSVP		-10

/***** Function prototypes *****/
static void	output_iface_pk_stats_update (Packet* pkptr, double * last_stat_update_time_ptr,
											OmsT_Bgutil_Routed_State * stat_bgutil_routed_state_ptr,
											Stathandle * packet_shandle_ptr);
static void	output_iface_packet_send (int q_index);
static void output_iface_stats_register (int q_index);
static void output_iface_information_print (void);
static void output_iface_warning_message_print (char* message);
static double output_iface_new_weight_get (void);
static Boolean output_iface_rsvp_is_enabled (void);

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Boolean	                		warning_frag_message_print;
	Boolean	                		warning_pk_dropped_message_printed;
	OmsT_Qm_Shared_Memory *			shared_mem_ptr;
	int	                    		interface_table_size;
	OmsT_Qm_Info *	         		qm_info;
	Boolean	                		processor_busy;
	Ici *	                  		arp_ici_ptr;
	List *	                 		stat_info_list_ptr;
	int	                    		interface_index;
	IpT_Queuing_Scheme	     		queuing_processing_scheme;
	int	                    		stat_index;
	int	                    		current_byte_count;
	int	                    		outstrm;
	Boolean	                		is_output_initialized;
	IpT_Interface_Info *	   		interface_info_ptr;
	RsvpT_TC_Ici_Struct *	  		rsvp_parameters_ptr;
	Stathandle	             		rsvp_allocated_bandwidth_stathandle;
	Stathandle	             		rsvp_allocated_buffer_stathandle;
	double	                 		rsvp_allocated_buffer;
	double	                 		rsvp_allocated_bandwidth;
	Packet *	               		sending_packet_ptr;
	double	                 		reservable_buffer_percentage;
	Stathandle	             		interface_buffer_size_stathandle;
	double	                 		max_reservable_bandwidth_per_flow;
	double	                 		max_reservable_bandwidth;
	Boolean	                		queue_to_be_deleted;
	Stathandle	             		virtual_clock_stamp_stathandle;
	Stathandle	             		a_virtual_clock_stamp_stathandle;
	Stathandle	             		service_time_stathandle;
	} ip_output_iface_VC1_state;

#define pr_state_ptr            		((ip_output_iface_VC1_state*) SimI_Mod_State_Ptr)
#define warning_frag_message_print		pr_state_ptr->warning_frag_message_print
#define warning_pk_dropped_message_printed		pr_state_ptr->warning_pk_dropped_message_printed
#define shared_mem_ptr          		pr_state_ptr->shared_mem_ptr
#define interface_table_size    		pr_state_ptr->interface_table_size
#define qm_info                 		pr_state_ptr->qm_info
#define processor_busy          		pr_state_ptr->processor_busy
#define arp_ici_ptr             		pr_state_ptr->arp_ici_ptr
#define stat_info_list_ptr      		pr_state_ptr->stat_info_list_ptr
#define interface_index         		pr_state_ptr->interface_index
#define queuing_processing_scheme		pr_state_ptr->queuing_processing_scheme
#define stat_index              		pr_state_ptr->stat_index
#define current_byte_count      		pr_state_ptr->current_byte_count
#define outstrm                 		pr_state_ptr->outstrm
#define is_output_initialized   		pr_state_ptr->is_output_initialized
#define interface_info_ptr      		pr_state_ptr->interface_info_ptr
#define rsvp_parameters_ptr     		pr_state_ptr->rsvp_parameters_ptr
#define rsvp_allocated_bandwidth_stathandle		pr_state_ptr->rsvp_allocated_bandwidth_stathandle
#define rsvp_allocated_buffer_stathandle		pr_state_ptr->rsvp_allocated_buffer_stathandle
#define rsvp_allocated_buffer   		pr_state_ptr->rsvp_allocated_buffer
#define rsvp_allocated_bandwidth		pr_state_ptr->rsvp_allocated_bandwidth
#define sending_packet_ptr      		pr_state_ptr->sending_packet_ptr
#define reservable_buffer_percentage		pr_state_ptr->reservable_buffer_percentage
#define interface_buffer_size_stathandle		pr_state_ptr->interface_buffer_size_stathandle
#define max_reservable_bandwidth_per_flow		pr_state_ptr->max_reservable_bandwidth_per_flow
#define max_reservable_bandwidth		pr_state_ptr->max_reservable_bandwidth
#define queue_to_be_deleted     		pr_state_ptr->queue_to_be_deleted
#define virtual_clock_stamp_stathandle		pr_state_ptr->virtual_clock_stamp_stathandle
#define a_virtual_clock_stamp_stathandle		pr_state_ptr->a_virtual_clock_stamp_stathandle
#define service_time_stathandle 		pr_state_ptr->service_time_stathandle

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	ip_output_iface_VC1_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
static void
output_iface_packet_send (int q_index)
	{
	int								next_address, pk_txtype;
	int								connection_class;
	int 							minor_port;
	Ici*							qos_ici_ptr;
	char							disp_string1 [255];
    int								q_size;
	double							arrival_time;
	int								packet_size;
	OmsT_Qm_Stat_Info *				stat_info_ptr;

	/** Sends the packet after associating the "next address"	**/
	/** and the "connection class" to the packet if required.	**/
	/** Write stats for 'Packets Sent'.							**/
	/** The packet is sent after the transmission time.			**/
	FIN (output_iface_packet_send (pkptr, q_index));

	/* Get the ICI of the packet.	*/
	qos_ici_ptr = op_pk_ici_get (sending_packet_ptr);

	/* Statistics are not written when the statistic dimension is exceeded.	*/
	if (shared_mem_ptr->statistic_index < IP_DIM_STAT_INDEX_MAX)		
		{
		/* Write the statistic for queuing delay.	*/
		op_ici_attr_get (qos_ici_ptr, "arrival_time", &arrival_time);
		stat_info_ptr = op_prg_list_access (stat_info_list_ptr, q_index);
		op_stat_write (stat_info_ptr->queuing_delay_stathandle, op_sim_time () - arrival_time);

		/* Write out a new data point for the "Traffic Sent" statistic	*/
		/* under the 'IP Interface' group.								*/
		packet_size = op_pk_total_size_get (sending_packet_ptr);
		op_stat_write (stat_info_ptr->traffic_sent_in_pps_stathandle, 1.0);
		op_stat_write (stat_info_ptr->traffic_sent_in_bps_stathandle, packet_size);

		/* Write out a zero value to signal the end of the duration to hold */
		/* the statistic at the previously written out value.				*/
		op_stat_write (stat_info_ptr->traffic_sent_in_pps_stathandle, 0.0);
		op_stat_write (stat_info_ptr->traffic_sent_in_bps_stathandle, 0.0);
        }
		
	/* Get the type of the packet in order to register stat for 'Packet Sent'.	*/
	op_ici_attr_get (qos_ici_ptr, "pkt_txtype", &pk_txtype);

	/* Determine if the lower layer, if any requires	*/
	/* information about the next interface, etc. for	*/
	/* further processing. NOTE that SLIP or PPP ifaces	*/
	/* do not require any ICI associations.				*/
	if (interface_info_ptr->intf_type == IpC_Intf_Type_Smart)
		{
		/* Get some information from the packet ICI, which		*/
		/* will be sent with the packet in another ICI to ARP.	*/
		op_ici_attr_get (qos_ici_ptr, "connection_class", &connection_class);
		op_ici_attr_get (qos_ici_ptr, "next_addr", &next_address);			
		op_ici_attr_get (qos_ici_ptr, "minor_port", &minor_port);

		/* Destroy the ICI of the packet. */
		op_ici_destroy (qos_ici_ptr);

		/* Set the ICI fields with the connection class.	*/
		if (op_ici_attr_set (arp_ici_ptr, "connection_class", connection_class) == OPC_COMPCODE_FAILURE)
			{
			output_iface_warning_message_print ("Unable to set an ICI for ARP");
			}

		/* Set the ICI fields with the next address.	*/
		if (op_ici_attr_set (arp_ici_ptr, "next_addr", next_address) == OPC_COMPCODE_FAILURE)
			{
			output_iface_warning_message_print ("Unable to set an ICI for ARP");
			}
		
		/* Set the ICI fields with the minor port.	*/
		if (op_ici_attr_set (arp_ici_ptr, "minor_port", minor_port) == OPC_COMPCODE_FAILURE)
			{
			output_iface_warning_message_print ("Unable to set an ICI for ARP");
			}

		/* The ICI is now installed.	*/
		op_ici_install (arp_ici_ptr);	
		}
	else
		{
		/* Destroy the ICI of the packet. */
		op_ici_destroy (qos_ici_ptr);
		}

	/* Update the "packets sent" statistics.							*/	
	/* These statistics take into account background traffic, if any.	*/
	output_iface_pk_stats_update (sending_packet_ptr, &shared_mem_ptr->sent_pk_last_update_time,
		shared_mem_ptr->sent_bgutil_state_ptr, shared_mem_ptr->locl_num_pkts_sent_hdl_ptr);
	
	/* Update the appropriate "Total X Packets Sent" statistic based on		*/
	/* value of the pkt_txtype parameter.									*/
	switch (pk_txtype)
		{
		case WFQ_PKT_TXTYPE_UCAST:
			{
			/* No additional stat update is necessary. 					*/
			break;
			}
		case WFQ_PKT_TXTYPE_MCAST:
			{
			op_stat_write (*shared_mem_ptr->locl_num_mcasts_sent_hdl_ptr, 1.0);
			/* Write out a zero value to signal the end of the duration to  */
			/* hold the statistic at the previously written out value.		*/
			op_stat_write (*shared_mem_ptr->locl_num_mcasts_sent_hdl_ptr, 0.0);
			break;
			}
		case WFQ_PKT_TXTYPE_BCAST:
			{
			op_stat_write (*shared_mem_ptr->locl_num_bcasts_sent_hdl_ptr, 1.0);
		
			/* Write out a zero value to signal the end of the duration to  */
			/* hold the statistic at the previously written out value.		*/
			op_stat_write (*shared_mem_ptr->locl_num_bcasts_sent_hdl_ptr, 0.0);
			break;
			}
		default:
			{
			/* Print an error message and exit the simulation. */
			op_sim_end (
				"Error in ip_output_iface process model :",
				"IP Datagram transmission not categorized.",
				"Check simulation log messages from the IP model for more information.",
				"Simulation Logging can be enabled/disabled in the Simulation Editor."); 
	
			break;
			}
		}

	if (LTRACE_QM)
		{
         sprintf (disp_string1, "Packet %d Transmission is Complete on Interface %d Queue %d", op_pk_id (sending_packet_ptr), interface_info_ptr->addr_index, q_index);
		op_prg_odb_print_minor (disp_string1, OPC_NIL);
		}

	/* Send the packet on the right stream.	*/
	op_pk_send_forced (sending_packet_ptr, outstrm);

	/* Check whether the queue is now empty when RSVP is enabled.	*/
	/* RSVP might have sent a request to delete this queue when		*/
	/* it was still containing packets.								*/
	if ((qm_info->queue_info_ptr[q_index]->queue_to_delete == OPC_TRUE) && 
		(q_index != QUEUE_DELETED_BY_RSVP) && (qm_info->rsvp_flag == OPC_TRUE) &&
		(op_prg_list_size (qm_info->queue_info_ptr[q_index]->pk_list_ptr) == 0))
        {
		/* Schedule an interrupt to delete this queue.	*/
		op_intrpt_schedule_self (op_sim_time (), q_index);

		/* Set the RSVP flag to indicate that a queue needs to be deleted.	*/
		queue_to_be_deleted = OPC_TRUE;

		/*$$DD$$*/
		qm_info->queue_to_service = QUEUE_DELETED_BY_RSVP;
		}

	FOUT;
	}


static void
output_iface_pk_stats_update (Packet* pkptr, double * last_stat_update_time_ptr,
	OmsT_Bgutil_Routed_State * stat_bgutil_routed_state_ptr,
	Stathandle * packet_shandle_ptr)
	{
	int				i;
	int				stat_updates_in_this_interval;
	double			update_time;
	double			routed_packets_per_sec;
	double			routed_pk_size_std_dev;
	double			update_interval;
	double			pks_per_update;
	double			dist_pks_per_update;
	double			curr_sim_time;
	double			pks_per_update_fraction;

	/**	Record the IP stats for packets sent and received.					**/
	/**	These statistics take into account background traffic, if any.		**/
	/** If the packet pointer is non-nil, we examine the packet to			**/
	/** determine if there is new background utilization traffic specified	**/
	/** in the packet.														**/
	FIN (output_iface_pk_stats_update (pkptr, last_stat_update_time_ptr, stat_bgutil_routed_state_ptr, packet_shandle_ptr));
	
	/* Store current simulation time.	*/
	curr_sim_time = op_sim_time ();

	if (shared_mem_ptr->bgutil == OPC_TRUE)
		{
		/* Check to see if we have a packet. */
		if (pkptr != OPC_NIL)
			{
			/* This packet might contain a background utilization tracer packet.			*/
			/* Obtain the background utilization till the current time.						*/
			/* The value returned denotes the background utilization which is valid until 	*/
			/* right before the current time.  This function is efficient if there is no	*/
			/* routed background utilization.												*/
			oms_bgutil_routed_utilization_get (stat_bgutil_routed_state_ptr, 
				pkptr, curr_sim_time, 1.0, &routed_packets_per_sec, 
				&routed_pk_size_std_dev, OmsC_Bgutil_Get_Prev);
			}
		else
			{
			/* We do not have a packet to examine, but we still need to purge 	*/
			/* any utilization that has expired and determine the current		*/
			/* utilization.	 This function is efficient if there is no			*/
			/* routed background utilization.									*/
			oms_bgutil_routed_table_purge_stale (curr_sim_time,
				&stat_bgutil_routed_state_ptr->table, &routed_packets_per_sec, &routed_pk_size_std_dev);
			}
		}
	
	if (shared_mem_ptr->bgutil == OPC_FALSE || routed_packets_per_sec == 0.0)
		{
		/* There is only explicitly modeled traffic. Record		*/
		/* statistics w.r.t. only explicit traffic.				*/
		/*	Calculate Statistics. In the model code (below), we	*/
		/*	will record the "<units>/sec" statistic in <units>	*/
		/*	where <units> can be "bits" or "packets". OPNET's	*/
		/*	statistics "capture mode" feature will be used to	*/
		/*	record it in <units>/sec.							*/ 
		op_stat_write (*packet_shandle_ptr,     1.0);
			
		/* Maintain time at which these statistics were last updated.	*/
		*last_stat_update_time_ptr = curr_sim_time;
		}
	else
		{
		/* Compute  statistics for the time upto			*/
		/* the current time. Find the time elapsed since	*/
		/* the last statistic update.						*/
		update_interval = curr_sim_time - *last_stat_update_time_ptr;
		
		/* Determine how many stat updates we should have 	*/
		/* during this interval.							*/
		stat_updates_in_this_interval = oms_bgutil_num_updates_get (update_interval);
		
		/* We will start our updates at the time of last stat update. */
		update_time = *last_stat_update_time_ptr;

		/* Background utilization delays are modeled using the 			*/
		/* op_dist_qwait_est KP where background utilization packet 	*/
		/* interarrivals are modeled as exponential interarrivals.  	*/
		/* For efficiency, for the stat updates here we will simplify 	*/
		/* and use a uniform distribution instead of a poisson 			*/
		/* distribution for the number of packet arrivals.				*/
		pks_per_update = routed_packets_per_sec * update_interval /
			(stat_updates_in_this_interval);
	
		/* Calculate the fraction of the packets per update we will use later. */
		pks_per_update_fraction = pks_per_update * OMSC_BGUTIL_DIST_FACTOR;
			
		/* Now we will loop and do several stat updates which represent */
		/* the routed background utilization traffic.					*/
		for (i = 0; i < stat_updates_in_this_interval; i++)
			{
			/* Obtain a utilization uniformly distributed around input_utilization. 			*/
			/* We don't use a utilization less than 0 but allow a utilization greater than 1. 	*/
			dist_pks_per_update = pks_per_update - pks_per_update_fraction + op_dist_uniform (2 * pks_per_update_fraction);
		
			/* Write the stat values for this update. */
			op_stat_write_t (*packet_shandle_ptr, dist_pks_per_update, update_time);
		
			/* Move forward to the next stat update time. */
			update_time += (update_interval / stat_updates_in_this_interval);
			}
		
		/* Update the statistic based on the current packet.	*/
		op_stat_write (*packet_shandle_ptr,     1.0);
		
		/* Maintain time at which this statistic was last updated.	*/
		*last_stat_update_time_ptr = curr_sim_time;
		}

	/* Write out a zero value to signal the end of the duration to  */
	/* hold the statistic at the previously written out value.		*/
	op_stat_write (*shared_mem_ptr->locl_num_pkts_sent_hdl_ptr, 0.0);
	FOUT;
	}

static void
output_iface_stats_register (int q_index)
	{
	char					new_name [200];
	int						port_number, statistic_index;
	char					queuing_scheme [10];
	OmsT_Qm_Stat_Info *		stat_info_ptr;

	/** Register statistics for one queue. The registration is only	**/
	/** made if the queue is actually used.							**/
	/** Note also that the dimension of the statistics is limited	**/
	/** IP_DIM_STAT_INDEX_STAT. If this value is reached, none of	**/
	/** the IP interface statistics will be witten.					**/
	FIN (output_iface_stat_register (q_index));

	/* Statistics are not written when the statistic dimension is exceeded.	*/
	if (shared_mem_ptr->statistic_index < IP_DIM_STAT_INDEX_MAX)		
		{
		/* Get the statistic index to register the statistic. This	*/
		/* index is common to all the output_iface child processes.	*/
		stat_index = shared_mem_ptr->statistic_index;

		/* If the access to the interface list fails the simulation ends.	*/
		if (interface_info_ptr == OPC_NIL)
			output_iface_warning_message_print ("Unable to access the interface list to register statistics.");

		switch (queuing_processing_scheme)
			{
			case IpC_FIFO_Queuing:
				{
				/* There is only one queue in FIFO.	*/
				sprintf (queuing_scheme, "FIFO");
				break;
				}

			case IpC_WFQ_Queuing:
				{
				sprintf (queuing_scheme, "WFQ");
				break;
        		}
				
			case IpC_VC_Queuing:
				{
				sprintf (queuing_scheme, "VC");
				break;
				}

			case IpC_Priority_Queuing:
				{
				sprintf (queuing_scheme, "PQ");
				break;
				}

			case IpC_Custom_Queuing:
				{
				sprintf (queuing_scheme, "CQ");
				break;
				}

			default:
				{
				/* No queuing processing has been chosen.	*/
				output_iface_warning_message_print ("Unknown Queuing scheme has been chosen");
				}
        	}

		/* Get the row number of the interface in the attribute	*/
		/* "IP Address Information". The statistic name will	*/
		/* include the same interface number as the one			*/
		/* which can be obtained by clicking on the link.		*/
		port_number = interface_info_ptr->addr_index;
	
		/* Get the queue statistic element.	*/
		stat_info_ptr = op_prg_list_access (stat_info_list_ptr, q_index);
		
		/* Initialize stathandle for Virtual Clock  */
		stat_info_ptr->virtual_clock_stathandle = op_stat_reg ( "IP Interface.Virtual Clock (Sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Virtual Clock (Sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->virtual_clock_stathandle, new_name);
		
		/* Initialize stathandle for Auxilary Virtual Clock.	*/
		stat_info_ptr->a_virtual_clock_stathandle = op_stat_reg ("IP Interface.Auxilary Virtual Clock (Sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Auxilary Virtual Clock (Sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->a_virtual_clock_stathandle, new_name);
		
		/* Initialize stathandle for Virtual Clock Stamp. 	*/
		stat_info_ptr->virt_clock_stamp_stathandle = op_stat_reg ( "IP Interface.Sending Virtual Clock Stamp", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Sending Virtual Clock Stamp IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->virt_clock_stamp_stathandle, new_name);
		
		/* Initialize stathandle for Auxilary Virtual Clock Stamp.	*/
		stat_info_ptr->a_virt_clock_stamp_stathandle = op_stat_reg ("IP Interface.Sending Auxilary Virtual Clock Stamp", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Sending Auxilary Virtual Clock Stamp IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->a_virt_clock_stamp_stathandle, new_name);
		
		
		/* Initialize stathandle for Buffer Usage.	*/
		stat_info_ptr->buffer_usage_in_pk_stathandle = op_stat_reg ("IP Interface.Buffer Usage (packets)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Buffer Usage (packets) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->buffer_usage_in_pk_stathandle, new_name);

		/* Initialize stathandle for Buffer Usage.	*/
		stat_info_ptr->buffer_usage_in_bytes_stathandle = op_stat_reg ("IP Interface.Buffer Usage (bytes)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Buffer Usage (bytes) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->buffer_usage_in_bytes_stathandle, new_name);

		/* Write the queue size to 0 for initialization.	*/
		op_stat_write (stat_info_ptr->buffer_usage_in_pk_stathandle, 0.0);		
		op_stat_write (stat_info_ptr->buffer_usage_in_bytes_stathandle, 0.0);

		/* Initialize stathandle for queuing delay.	*/
		stat_info_ptr->queuing_delay_stathandle = op_stat_reg ("IP Interface.Queuing Delay", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Queuing Delay IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->queuing_delay_stathandle, new_name);

		/* Initialize stathandle for traffic dropped.	*/
		stat_info_ptr->traffic_dropped_in_pps_stathandle = op_stat_reg ("IP Interface.Traffic Dropped (packets/sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Traffic Dropped (packets/sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->traffic_dropped_in_pps_stathandle, new_name);

		stat_info_ptr->traffic_dropped_in_bps_stathandle = op_stat_reg ("IP Interface.Traffic Dropped (bits/sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Traffic Dropped (bits/sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->traffic_dropped_in_bps_stathandle, new_name);

		/* Initialize stathandle for traffic sent.	*/
		stat_info_ptr->traffic_sent_in_pps_stathandle = op_stat_reg ("IP Interface.Traffic Sent (packets/sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Traffic Sent (packets/sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->traffic_sent_in_pps_stathandle, new_name);

		stat_info_ptr->traffic_sent_in_bps_stathandle = op_stat_reg ("IP Interface.Traffic Sent (bits/sec)", stat_index, OPC_STAT_LOCAL);	
		sprintf (new_name, "%s Traffic Sent (bits/sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->traffic_sent_in_bps_stathandle, new_name);

		/* Initialize stathandle for traffic received.	*/
		stat_info_ptr->traffic_received_in_pps_stathandle = op_stat_reg ("IP Interface.Traffic Received (packets/sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Traffic Received (packets/sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->traffic_received_in_pps_stathandle, new_name);

		stat_info_ptr->traffic_received_in_bps_stathandle = op_stat_reg ("IP Interface.Traffic Received (bits/sec)", stat_index, OPC_STAT_LOCAL);
		sprintf (new_name, "%s Traffic Received (bits/sec) IF%d Q%d", queuing_scheme, port_number, q_index);
		op_stat_rename (stat_info_ptr->traffic_received_in_bps_stathandle, new_name);

		/* Register RED statistics if RED is enabled.	*/
		if (qm_info->attributes_ptr->queue_configuration [q_index]->red_status == OmsC_Red )
			{
			stat_info_ptr->red_average_queue_size_stathandle = op_stat_reg ("IP Interface.RED Average Queue Size", stat_index, OPC_STAT_LOCAL);
			sprintf (new_name, "RED Average Queue Size IF%d Q%d", port_number, q_index);
			op_stat_rename (stat_info_ptr->red_average_queue_size_stathandle, new_name);
			}
		
		/* Register WRED statistics if WRED is enabled.	*/
		if (qm_info->attributes_ptr->queue_configuration [q_index]->red_status == OmsC_Wred )
			{
			stat_info_ptr->red_average_queue_size_stathandle = op_stat_reg ("IP Interface.RED Average Queue Size", stat_index, OPC_STAT_LOCAL);
			sprintf (new_name, "WRED Average Queue Size IF%d Q%d", port_number, q_index);
			op_stat_rename (stat_info_ptr->red_average_queue_size_stathandle, new_name);
			}

		/* Set the queue statistics as registered. It will avoid them	*/
		/* to be registered again.										*/
		stat_info_ptr->stat_is_registered = OPC_TRUE;

		/* Increments the statistic index. It keeps track of the number of	*/
		/* queues which are active (and thus registered statistics.)		*/
		shared_mem_ptr->statistic_index ++;
		}
	else
		{
		/* Write a notification log if the statistic dimension is exceeded. 	*/
		/* To change the dimension to a higher value, go to the header block	*/
		/* and change the value of IP_DIM_STAT_INDEX_MAX. Then change the		*/
		/* actual statistic dimension of all local statistics under the 		*/
		/* 'Interface->Local Statictics' menu.									*/
		qosnl_confwarn_stat_dim_exceed (op_sim_time (), IP_DIM_STAT_INDEX_MAX);
		}

	FOUT;
	}

static void
output_iface_information_print (void)
	{
	int										queue_index, filter_index, number_of_filters = 0;
	char									str1 [255], str2 [255], scheme [255];
	char									str3 [255], str4 [255], str5 [255];
	char									str6 [255], str7 [255];
	OmsT_Qm_Classification_Criteria	*		filter_ptr;
	char									address [255];
	/** Print queuing information in ODB.	**/
	FIN (output_iface_information_print ());

	/* Get the queuing processing scheme.	*/
	switch (queuing_processing_scheme)
		{
		case IpC_FIFO_Queuing:
			{
			strcpy (scheme, "FIFO");
			break;
			}

		case IpC_WFQ_Queuing:
			{
			strcpy (scheme, "WFQ");
			break;
        	}
			
		case IpC_VC_Queuing:
			{
			strcpy (scheme, "VC");
			break;
			}

		case IpC_Priority_Queuing:
			{
			strcpy (scheme, "Priority Queuing");
			break;
			}

		case IpC_Custom_Queuing:
			{
			strcpy (scheme, "Custom Queuing");
			break;
			}

		default:
			{
			/* No queuing processing has been chosen.	*/
			strcpy (scheme, "No Queuing");
			}
        }

	if (queuing_processing_scheme != IpC_FIFO_Queuing)
		{
		/* Get the total number of filters through all queues.	*/
		number_of_filters = op_prg_list_size (qm_info->attributes_ptr->classification_list_ptr);
	    }

	/* Loop through all the queues.	*/
	for (queue_index = 0; queue_index < qm_info->attributes_ptr->no_queues; queue_index ++)
		{
		sprintf (str1, "%s Parameters (IF %d Queue %d)\n", scheme, interface_info_ptr->addr_index, queue_index);
		sprintf (str2, "Current Queue Size:\t%d", op_prg_list_size (qm_info->queue_info_ptr [queue_index]->pk_list_ptr));
		op_prg_odb_print_minor ("***************************************", str1, str2, OPC_NIL);
		
		sprintf (str1, "Maximum Queue Size:\t%d", qm_info->attributes_ptr->queue_configuration[queue_index]->max_size);
		sprintf (str2, "Queue Weight:\t\t%f", qm_info->attributes_ptr->queue_configuration[queue_index]->weight);
		sprintf (str3, "Queue Byte Count:\t%f", qm_info->attributes_ptr->queue_configuration[queue_index]->byte_count_number);
		sprintf (str4, "Arrival Rate:\t%f", qm_info->attributes_ptr->queue_configuration[queue_index]->arrival_rate);
		op_prg_odb_print_minor (str1, str2, OPC_NIL);

		if (qm_info->attributes_ptr->queue_configuration [queue_index]->red_status != 0)
			{
			sprintf (str1, "RED/WRED Average Queue Size:\t%f", qm_info->queue_info_ptr[queue_index]->average_queue_size);
			sprintf (str2, "RED/WRED Last Start Idle Time:\t%f\n", qm_info->queue_info_ptr[queue_index]->start_idle_time);
			op_prg_odb_print_minor (str1, str2, OPC_NIL);
			}
		else
			{
			op_prg_odb_print_minor ("RED/WRED is disabled\n", OPC_NIL);
			}

		/* Loop through all the classification schemes and print filters related	*/
		/* to the present queue and all its attributes.								*/
		for (filter_index = 0; filter_index < number_of_filters; filter_index ++)
			{
			/* Get the filter information.	*/
			filter_ptr = op_prg_list_access (qm_info->attributes_ptr->classification_list_ptr, filter_index);

			/* Print the filter information if it is related to the queue.	*/
			if (filter_ptr->queue_id == queue_index)
				{
				sprintf (str1, "Type of service: \t%d", filter_ptr->tos);
				sprintf (str2, "Protocol: \t\t%d", filter_ptr->protocol);
				ip_address_print (address, filter_ptr->source_address);
				sprintf (str3, "Source address:\t\t%s", address);
				ip_address_print (address, filter_ptr->dest_address);
				sprintf (str4, "Destination Address:\t%s", address);
				sprintf (str5, "Source port:\t\t%d", filter_ptr->source_port);
				sprintf (str6, "Destination port:\t%d", filter_ptr->dest_port);
				sprintf (str7, "Incoming interface:\t%d\n", filter_ptr->incoming_iface);
				op_prg_odb_print_minor ("------------Filter------------", str1, str2, str3, str4, str5, str6, str7, OPC_NIL);
				}
			}
		}

	FOUT;
	}

static void
output_iface_warning_message_print (char* message)
	{
	/** Ends the simulation and print a error message.	**/
	FIN (output_iface_warning_message_print (message));

	op_sim_end ("Error in ip_output_iface process model\n", message, "", "");

	FOUT;
	}

static double
output_iface_new_weight_get (void)
	{
	double						required_data_rate;
	double						required_priority;
	char						str1 [255], str2 [255];

    /** Returns the weight matching the bandwidth required	**/
	/** by RSVP. This weight will be then used by WFQ to	**/
	/** allocate bandwidth.	If not enough bandwidth is		**/
	/** available, the function will BANDWIDTH_EXCEEDED.	**/
	FIN (output_iface_new_weight_get ())

	/* Get the amount of bandwidth required for the new queue (in bytes/sec).	*/
	required_data_rate = rsvp_parameters_ptr->tspec_ptr->bucket_rate;

	/* Check whether RSVP does not allocate to much bandwidth for one flow.	*/
	if (required_data_rate * 8 > max_reservable_bandwidth_per_flow * interface_info_ptr->speed / 100)
		{
		/* Writing traces for ODB.	*/
		if (LTRACE_RSVP)
			{
			sprintf (str1, "Requested bandwidth for the flow (bytes/sec):\t%f", required_data_rate);
			sprintf (str2, "Max reservable bandwidth per flow (bytes/sec):\t%f", max_reservable_bandwidth_per_flow * interface_info_ptr->speed / 800); 
			op_prg_odb_print_major ("Trying to allocate too much bandwidth for a single flow", str1, str2, OPC_NIL);
			}
		
		/* RSVP allocates too much bandwidth for a flow.	*/	
		FRET (IP_IFACE_INSUFF_WEIGHT);
		}

	/* Check whether there is enough buffer space. We use the same percentage	*/
	/* for reservable buffer as for reservable bandwidth.						*/
	if (rsvp_parameters_ptr->tspec_ptr->bucket_size > qm_info->max_buffer_size * max_reservable_bandwidth / 100 - rsvp_allocated_buffer)
		{
		/* Writing traces for ODB.	*/
		if (LTRACE_RSVP)
			{
			sprintf (str1, "Requested buffer (bytes):\t%f", rsvp_parameters_ptr->tspec_ptr->bucket_size);
			sprintf (str2, "Available buffer (bytes):\t%f", qm_info->max_buffer_size * 
								max_reservable_bandwidth / 100 - rsvp_allocated_buffer);
			op_prg_odb_print_major ("Unsufficient buffer space", str1, str2, OPC_NIL);
			}

		/* There is not enough buffer space for the RSVP request.	*/
		FRET (IP_IFACE_INSUFF_WEIGHT);
		}

	/* Compute the priority factor for the request depending on	*/
	/* the queuing processing scheme.							*/
	switch (queuing_processing_scheme)
		{
		case IpC_WFQ_Queuing:
			{
			/* Compute the weight necessary for allocating this bandwidth to the queue.	*/
			required_priority = required_data_rate * 8 * 100 / interface_info_ptr->speed;

			/* Writing traces for ODB.	*/
			if (LTRACE_RSVP)
				{
				sprintf (str1, "Requested bandwidth (bytes/sec):\t%f", required_data_rate);
				sprintf (str2, "Available bandwidth (bytes/sec):\t%f", (100 - qm_info->total_weight) / 800 * interface_info_ptr->speed);
				op_prg_odb_print_major ("RSVP request", str1, str2, OPC_NIL);
               	}

			/* Check whether there is enough bandwidth.	*/
			if (required_priority > 100 - qm_info->total_weight)
				{
				/* Writing traces for ODB.	*/
				if (LTRACE_RSVP)
					{
					op_prg_odb_print_minor ("Unsufficient bandwidth", OPC_NIL);
                	}

				/* There is not enough bandwidth. The new queue	won't be created.	*/
     		    FRET (IP_IFACE_INSUFF_WEIGHT);
				}

			break;
			}

		case IpC_Custom_Queuing:
			{
			/* Compute the byte count necessary for allocating this bandwidth to the queue.	*/
			required_priority = (int) (required_data_rate * 8 * OmsC_Rsvp_Total_Byte_Count / interface_info_ptr->speed);

			if (LTRACE_RSVP)
				{
				sprintf (str1, "Requested bandwidth (bytes/sec):\t%f", required_data_rate);
				sprintf (str2, "Available bandwidth (bytes/sec):\t%f", qm_info->total_weight * interface_info_ptr->speed / (8 * OmsC_Rsvp_Total_Byte_Count));
				op_prg_odb_print_major ("RSVP request", str1, str2, OPC_NIL);
               	}

			/* Check whether there is enough bandwidth.	*/
			if (required_priority > OmsC_Rsvp_Total_Byte_Count - qm_info->total_weight)
				{
				/* Writing traces for ODB.	*/
				if (LTRACE_RSVP)
					{
					op_prg_odb_print_minor ("Unsufficient bandwidth", OPC_NIL);
                	}

				/* There is not enough bandwidth. The new queue	won't be created.	*/
     		   	FRET (IP_IFACE_INSUFF_WEIGHT);
				}

			break;
			}

		default:
			/* RSVP is supposed to work with WFQ or custom queuing.	*/
			output_iface_warning_message_print ("WFQ or Custom Queuing should be enabled for RSVP.");
		}

	/* There is enough bandwidth and buffer space. Returns the weight corresponding	*/
	/* to the bandwidth allocated to the queue.										*/
	FRET (required_priority);
	}

static Boolean
output_iface_rsvp_is_enabled (void)
	{
	Objid			module_objid;
	Objid			ip_addr_info_objid, ip_addr_info_child_objid;
	Objid			qos_info_objid, qos_info_child_objid;
	Objid			rsvp_info_objid, rsvp_info_child_objid;
	Boolean			rsvp_is_enabled;

	FIN (output_iface_rsvp_is_enabled ());
	/** This function returns whether RSVP is enabled on the interface	**/
	/** of which this process model is in charge.						**/

	/* Obtain the module identifier.		*/
	module_objid = op_id_self ();

	/* Get the handle to the attribute called "IP Address Information".	*/
	op_ima_obj_attr_get (module_objid, "ip addr info", &ip_addr_info_objid);
	ip_addr_info_child_objid = op_topo_child (ip_addr_info_objid, OPC_OBJTYPE_GENERIC, interface_info_ptr->addr_index);

	/* Get the handle to the sub-attribute called "QoS info".	*/
	op_ima_obj_attr_get (ip_addr_info_child_objid, "QoS info", &qos_info_objid);
	qos_info_child_objid = op_topo_child (qos_info_objid, OPC_OBJTYPE_GENERIC, 0);

	/* Get the handle to the sub-attribute called "RSVP Info".	*/
	op_ima_obj_attr_get (qos_info_child_objid, "RSVP Info", &rsvp_info_objid);
	rsvp_info_child_objid = op_topo_child (rsvp_info_objid, OPC_OBJTYPE_GENERIC, 0);

	/* Get the handle to the sub-attribute called "RSVP Status".	*/
	op_ima_obj_attr_get (rsvp_info_child_objid, "RSVP Status", &rsvp_is_enabled);

	/* Get the handle to the sub-attribute called "Max Reservable Bandwidth".	*/
	op_ima_obj_attr_get (rsvp_info_child_objid, "Max Reservable Bandwidth", &max_reservable_bandwidth);

	/* Get the handle to the sub-attribute called "Per Flow Max Reservable Bandwidth".	*/
	op_ima_obj_attr_get (rsvp_info_child_objid, "Per Flow Max Reservable Bandwidth", &max_reservable_bandwidth_per_flow);

	FRET (rsvp_is_enabled);
	}

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void ip_output_iface_VC1 (void);
	Compcode ip_output_iface_VC1_init (void **);
	void ip_output_iface_VC1_diag (void);
	void ip_output_iface_VC1_terminate (void);
	void ip_output_iface_VC1_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
ip_output_iface_VC1 (void)
	{
	int _block_origin = 0;
	FIN (ip_output_iface_VC1 ());
	if (1)
		{
		OmsT_Qm_Prio_Classifier_Func_Ptr		function_ptr;
		int										insert_ok;
		Packet *  								pkptr;
		int										queue_id;
		double									time_to_service;
		Ici *									qos_ici_ptr;
		char									disp_string1 [255];
		char 									disp_string2 [255];
		OmsT_Qm_Pkt_Info 						pkt_info;
		int										q_size;
		char									new_name [200];
		int										q_index;
		int										pk_size;
		double									current_time;
		List *									interface_table_ptr;
		OmsT_Qm_Stat_Info *						stat_info_ptr;
		
		/* Variables defined for Virtual Clock algorithm          */
		double 									v_clock;
		double									a_v_clock = 0;
		double									c_v_clock = 0;
		double									arr_rate;
		double									v_tick = 0;
		double									min;
		int										min_vc_q_index;
		int										no_eqvc_queues;
		int										j;
		int										active_q_index[10];
		Packet *								packetptr;
		double									virtual_clock_stamp;
		double									a_virtual_clock_stamp;
		
		/* Used to determine the mode with which this process got */
		/* interrupted.  Useful in determining transitions from   */
		/* the "idle" state.                                      */
		int										invocation_mode = OPC_INT_UNDEF;
		
		/* Variable used when RSVP is enabled.	*/
		RsvpT_TC_Downcall_Type					rsvp_call_type;
		int										number_of_queues;
		double									weight;
		OmsT_Qm_Queue_Configuration **			new_queue_configuration_ptr;
		OmsT_Qm_Queue_Info **					new_queue_info_ptr;
		OmsT_Qm_Classification_Criteria *		classification_element_ptr;
		int										number_of_schemes;
		int										list_index;
		int										scheme_id;
		OmsT_Qm_Classification_Criteria *		scheme_ptr;
		int										packet_id;
		int										deleted_queue_size;


		FSM_ENTER (ip_output_iface_VC1)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (enqueue) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "enqueue", "ip_output_iface_VC1 () [enqueue enter execs]")
				{
				/** This state is in charge of enqueuing the incoming		**/
				/** packet. This packet will be put in one of the list		**/
				/** of the interface qm_info structure. Then if the			**/
				/** interface processor is free the packet will be sent.	**/
				/** Note that the packet is immediately sent if all queues	**/
				/** are empty.												**/
				
				/* Acquire the incoming packet from the argument memory.	*/
				if ((pkptr = op_pro_argmem_access ()) == OPC_NIL)
					{
					/* Stop the simulation if the packet can not be accessed.	*/
					output_iface_warning_message_print ("Unable to get the packet from the parent process ip_rte_v4");
				    }
				
				/* Get the ICI coming with the packet.	This ICI			*/
				/* will carry the arrival time and virtual arrival time.	*/
				qos_ici_ptr = op_pk_ici_get (pkptr);
				
				/* Ends the simulation if there is no ICI.  */
				if (qos_ici_ptr == OPC_NIL)
					{
					output_iface_warning_message_print ("The ICI 'qos_ici_ptr' is NIL.");
					}
				
				/* Get the size of the packet. This will be used to		*/
				/* write statistics.									*/
				pk_size = op_pk_total_size_get (pkptr);
				
				/* If there is no connected interface the packet comes	*/
				/* from the higher layer. It will be destroyed.			*/
				if (interface_table_size == 0)
					{
					/* Destroy the ICI of the packet.	*/
					op_ici_destroy (qos_ici_ptr);
				
					/* Destroy the packet.	*/
					op_pk_destroy (pkptr);
				
					/* Write out a new data point for the "Dropped Packets" statistic.	*/	
					op_stat_write (*shared_mem_ptr->locl_pk_dropped_hdl_ptr, 1.0);
					op_stat_write (*shared_mem_ptr->globl_pk_dropped_hdl_ptr, 1.0);
				
					/* Write out a zero value to signal the end of the duration to hold */
					/* the statistic at the previously written out value.				*/
					op_stat_write (*shared_mem_ptr->locl_pk_dropped_hdl_ptr, 0.0);
					op_stat_write (*shared_mem_ptr->globl_pk_dropped_hdl_ptr, 0.0);
					}
				else
					{
				    /* There is at least one connected interface. If all the queues	*/
					/* of the interface are empty, the packet is not enqueued but	*/
					/* sent immediately for efficiency purpose.						*/
					if (processor_busy == OPC_FALSE)
						{
						/* Get the queue id where the packet went through even		*/
						/* though it has not been explicitly enqueued. The queue	*/
						/* identifier is needed to write statistic per queue.		*/
						if (queuing_processing_scheme == IpC_FIFO_Queuing)
							{
							/* There is only one, unique queue in the FIFO scheme.	*/
							queue_id = 0;
							}
				  	  	else
							{
							/* Get the queue in which the packet is supposed to go through.	*/
							pkt_info = ip_qos_tos_classifier_obtain (pkptr, qm_info, &warning_frag_message_print);
							queue_id = pkt_info.queue_id;
							}
				
						/* Calculate the time it will take to send the packet.	*/
						time_to_service = op_pk_total_size_get (pkptr) / qm_info->service_rate;
						
						/* Vitual Clock is the queuing scheme, then			    */
						if (queuing_processing_scheme == IpC_VC_Queuing )
							{
							
							/* If this is the first packt comming into the queue initialize the Virtual Clock */
							/* and Auxilary Virtual Clock of the queue to the current simulation time.        */
							
							if ( qm_info->attributes_ptr->queue_configuration[queue_id]->first_packet_flag == OPC_FALSE )
								{
								current_time = op_sim_time ();
								qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock = current_time;
								qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock = current_time;
								qm_info->attributes_ptr->queue_configuration[queue_id]->first_packet_flag = OPC_TRUE;
								}
							
							/* set the arrival rate to the value defined for that partucular queue 	*/
							arr_rate =	qm_info->attributes_ptr->queue_configuration[queue_id]->arrival_rate;
							v_tick = 1 / arr_rate;
										
						    /* initialization of virtual clock and auxilary virtual clock				*/
							v_clock = qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock;
							a_v_clock = qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock;
							
																								 	
							/* Get the current time.	*/
							current_time = op_sim_time ();
																								 
							if ( current_time >= a_v_clock )
								{
								 a_v_clock = current_time;
								}
						    /* Calculation of virtual clock and auxilary virtual clock	*/
							v_clock = v_clock + v_tick;
							a_v_clock = a_v_clock + v_tick;
							
							
							/* returning the values for virtual_time and aux_virtual_time to the qm_info structure */
							qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock = v_clock;
							qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock = a_v_clock;
								
								
									
										
							/* The virtual Clock and Auxilary Virtual Clock stamps are inserted in */
							/* the ICI. They are used in the extract state for choosing a queue    */
							/* containing a packet with the lowest Auxilary Virtual Clock Value    */
							
							op_ici_attr_set (qos_ici_ptr, "virtual_clock_stamp",qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock );
					        op_pk_ici_set (pkptr, qos_ici_ptr);
							
							op_ici_attr_set (qos_ici_ptr, "a_virtual_clock_stamp",qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock );
					        op_pk_ici_set (pkptr, qos_ici_ptr);
										
							}
					
						/* Schedule an interrupt. The interrupt code is the output	*/
						/* queue number. This interrupt will signal the end of		*/
						/* transmission.											*/
						op_intrpt_schedule_self (op_sim_time () + time_to_service, queue_id);
				
						/* Display for the debugger the time at which the packet	*/
						/* has been sent, and warns that the packet has not been	*/
						/* enqueued for efficiency reasons.							*/		
						if (LTRACE_QM)
							{
							sprintf (disp_string1, "The packet has not been Enqueued but Immediately Sent.");
				            sprintf (disp_string2, "Time at which the Packet is Sent: %f", op_sim_time ());
							op_prg_odb_print_major ("*** The Packet is Sent ***", disp_string1, disp_string2, OPC_NIL);
							}
				
						/* Check whether statistics have been registered for the queue. If not,	*/
						/* statistics will all be registered for the current queue.				*/
						stat_info_ptr = op_prg_list_access (stat_info_list_ptr, queue_id);
						if (stat_info_ptr->stat_is_registered == OPC_FALSE)
							{
							output_iface_stats_register (queue_id);
							}
				
					    /* The present time is inserted in the ICI. It is the   */
					    /* arrival time of the packet which will be used in the */
					    /* computation of the queuing delay later.				*/
					    qm_info->last_real_time = op_sim_time ();
					    op_ici_attr_set (qos_ici_ptr, "arrival_time", qm_info->last_real_time);
					    op_pk_ici_set (pkptr, qos_ici_ptr);
						
						/* If queuing scheme is Virtual Clock srite statistics for	*/
						/* Virtual Clock and Auxilary Virtual Clock upon arrival of	*/
						/* the packets.												*/
						
						if ( queuing_processing_scheme == IpC_VC_Queuing)
							{
							op_stat_write (stat_info_ptr->virtual_clock_stathandle, qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock);
							op_stat_write (stat_info_ptr->a_virtual_clock_stathandle, qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock);
							
									
							}
				        
						
								
						/* Set some extra parameters for the WFQ algorithm.	*/
						if (queuing_processing_scheme == IpC_WFQ_Queuing)
							{
							/* Set the virtual arrival time and the sum of weights	*/
							/* for all active queues, which might be used in the	*/
							/* WFQ equation later.									*/
					    	qm_info->last_virtual_time = 0;
				        	op_ici_attr_set (qos_ici_ptr, "virtual_arrival_time", qm_info->last_virtual_time);
							qm_info->total_active_weight = qm_info->attributes_ptr->queue_configuration[queue_id]->weight;
				            }
				
				        /* The packet will start being transmitted. An interrupt has been scheduled		*/
						/* at the end of the transmission. The packet will be sent to the lower layers	*/
						/* at this time.																*/
						sending_packet_ptr = pkptr;
					
						/* Store the queue being serviced.	*/
						qm_info->queue_to_service = queue_id;
				
						if (LTRACE_QM)
							{
				    	    sprintf (disp_string1, "Packet %d Transmission Starts on Interface %d Queue %d", op_pk_id (sending_packet_ptr), interface_info_ptr->addr_index, queue_id);
							op_prg_odb_print_minor (disp_string1, OPC_NIL);
							}
				
						/* Mark the processor of the interface as busy now	*/
						processor_busy = OPC_TRUE;
						}
					else
						{
						/* Each interface has many queues -- the incoming packet is	*/
						/* inserted in one of these queues, depending upon the		*/
						/* specified parameters. A function specific to each		*/
						/* client of this process (e.g., IP) is used to determine	*/
						/* the priority to be assigned to this packet.				*/ 
						if (queuing_processing_scheme == IpC_FIFO_Queuing)
							{
							/* Insert the packet in the only existing queue.	*/
							function_ptr = ip_qos_fifo_classifier_obtain;
							insert_ok = Oms_Qm_Packet_Enqueue (pkptr, qm_info, function_ptr, &warning_frag_message_print, &queue_id);
							}
						else
							{
							/* Insert the packet according to the classification	*/
							/* table in the IP QoS configuration object.			*/
							
							function_ptr = ip_qos_tos_classifier_obtain;
							insert_ok = Oms_Qm_Packet_Enqueue (pkptr, qm_info, function_ptr, &warning_frag_message_print, &queue_id);
							
							if (queuing_processing_scheme == IpC_VC_Queuing )
								{
								
								pkt_info = ip_qos_tos_classifier_obtain (pkptr, qm_info, &warning_frag_message_print);
							    queue_id = pkt_info.queue_id;
								
								/* If this is the first packt comming into the queue initialize the Virtual Clock */
							    /* and Auxilary Virtual Clock of the queue to the current simulation time.        */
							
							    if ( qm_info->attributes_ptr->queue_configuration[queue_id]->first_packet_flag == OPC_FALSE )
									{
									current_time = op_sim_time ();
									qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock = current_time;
									qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock = current_time;
									qm_info->attributes_ptr->queue_configuration[queue_id]->first_packet_flag = OPC_TRUE;
									}
								
									
								/* set the arrival rate to the value defined for that particular queue 	*/
								arr_rate =	qm_info->attributes_ptr->queue_configuration[queue_id]->arrival_rate;
								v_tick = 1 / arr_rate;
								
								/* initialization of virtual clock and auxilary virtual clock				*/
								v_clock = qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock;
								a_v_clock = qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock;
																								 	
								/* Get the current time.	*/
								current_time = op_sim_time ();
																								 
								if ( current_time >= a_v_clock )
									{
									a_v_clock = current_time;
									}
								/* Calculation of virtual clock and auxilary virtual clock	*/
								v_clock = v_clock + v_tick;
								a_v_clock = a_v_clock + v_tick;
								
								/* returning the values for virtual_time and aux_virtual_time to the qm_info structure */
								qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock = v_clock;
								qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock = a_v_clock;
								
												
															
								/* The virtual Clock and Auxilary Virtual Clock stamps are inserted in */
							    /* the ICI. They are used in the extract state for choosing a queue    */
							    /* containing a packet with the lowest Auxilary Virtual Clock Value    */
							
							    op_ici_attr_set (qos_ici_ptr, "virtual_clock_stamp",qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock );
					            op_pk_ici_set (pkptr, qos_ici_ptr);
							
							    op_ici_attr_set (qos_ici_ptr, "a_virtual_clock_stamp",qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock );
					            op_pk_ici_set (pkptr, qos_ici_ptr);
								
								
								
								}
								
							}
				
						/* Get the current time.	*/
						current_time = op_sim_time ();
				
						/* Set some extra parameters for the WFQ algorithm.	*/
						if (queuing_processing_scheme == IpC_WFQ_Queuing)
							{
							/* The virtual arrival time is inserted in the ICI. It is the   */
				    		/* virtual arrival time of the packet which will be used in the */
				    		/* WFQ equation later.											*/
				 			qm_info->last_virtual_time = qm_info->last_virtual_time + (current_time - qm_info->last_real_time) / qm_info->total_active_weight * qm_info->total_weight;
				   			op_ici_attr_set (qos_ici_ptr, "virtual_arrival_time", qm_info->last_virtual_time);
				
							/* Keep track of the sum of the weights of all active queues.	*/
							/* It will used in the WFQ equation later.						*/
				    		if ((op_prg_list_size (qm_info->queue_info_ptr[queue_id]->pk_list_ptr) == 1) && (queue_id != qm_info->queue_to_service))
				    		    {
				    		    qm_info->total_active_weight = qm_info->attributes_ptr->queue_configuration[queue_id]->weight + qm_info->total_active_weight;
				    		    }
				            }
				
						/* The current time is inserted in the ICI. It is the   */
				    	/* arrival time of the packet which will be used in the */
				    	/* computation of the queuing delay.					*/
				    	qm_info->last_real_time = current_time;
						op_ici_attr_set (qos_ici_ptr, "arrival_time", current_time);
					    op_pk_ici_set (pkptr, qos_ici_ptr);
				
						/* Check whether statistics have been registered for the queue. If not,	*/
						/* statistics will all be registered.									*/
						stat_info_ptr = op_prg_list_access (stat_info_list_ptr, queue_id);
						if (stat_info_ptr->stat_is_registered == OPC_FALSE)
							{
							output_iface_stats_register (queue_id);
							}
						
						/* If queuing scheme is Virtual Clock write statistics for	*/
						/* Virtual Clock and Auxilary Virtual Clock upon arrival of	*/
						/* the packets.												*/
						
						if ( queuing_processing_scheme == IpC_VC_Queuing)
							{
							op_stat_write (stat_info_ptr->virtual_clock_stathandle, qm_info->attributes_ptr->queue_configuration[queue_id]->virtual_clock);
							op_stat_write (stat_info_ptr->a_virtual_clock_stathandle, qm_info->attributes_ptr->queue_configuration[queue_id]->aux_virtual_clock);
							
							}
						
				
						/* In case of a congestion the packet is dropped. Statistics	*/
						/* are updated and a simulation notification is written to		*/
						/* warn that some packets might be dropped.						*/
						if (insert_ok == OPC_FALSE)
							{
							/* Print a notification log message to tell			*/
							/* that a packet has been dropped for congestion	*/
							/* reasons. It is displayed only once.				*/
							if (warning_pk_dropped_message_printed == OPC_FALSE)
								{
								wfqnl_protwarn_pkdropped (op_pk_id (pkptr), op_pk_tree_id (pkptr));
								warning_pk_dropped_message_printed = OPC_TRUE;
								}
				
							/* Write out a new data point for the "Traffic Dropped" statistic	*/
							/* under the 'IP Interface' group. Statistics are not written		*/
							/* if the statistic dimension is exceeded.							*/
							if (shared_mem_ptr->statistic_index < IP_DIM_STAT_INDEX_MAX)		
								{
								op_stat_write (stat_info_ptr->traffic_dropped_in_pps_stathandle, 1.0);
								op_stat_write (stat_info_ptr->traffic_dropped_in_bps_stathandle, pk_size);
				            	
								/* Write out a zero value to signal the end of the duration to hold */
								/* the statistic at the previously written out value.				*/
								op_stat_write (stat_info_ptr->traffic_dropped_in_pps_stathandle, 0.0);
								op_stat_write (stat_info_ptr->traffic_dropped_in_bps_stathandle, 0.0);
								}
				
							/* Write out a new data point for the "Dropped Packets" statistic	*/
							/* under the 'IP' group.											*/
							op_stat_write (*shared_mem_ptr->locl_pk_dropped_hdl_ptr, 1.0);
							op_stat_write (*shared_mem_ptr->globl_pk_dropped_hdl_ptr, 1.0);
				
							/* Write out a zero value to signal the end of the duration to hold */
							/* the statistic at the previously written out value.				*/
							op_stat_write (*shared_mem_ptr->locl_pk_dropped_hdl_ptr, 0.0);
							op_stat_write (*shared_mem_ptr->globl_pk_dropped_hdl_ptr, 0.0);
				
							/* Get the ICI for the pointer to be dropped.	*/	
							qos_ici_ptr = op_pk_ici_get (pkptr);
				
							/* Destroy the ICI of the packet.	*/
							op_ici_destroy (qos_ici_ptr);
				    	    	
							/* Destroy the packet.	*/
							op_pk_destroy (pkptr);
							}
						else
							{
							/* Statistics are not written when the statistic dimension is exceeded.	*/
							if (shared_mem_ptr->statistic_index < IP_DIM_STAT_INDEX_MAX)		
								{
								/* Write a statistic for buffer_usage.	*/
								q_size = op_prg_list_size (qm_info->queue_info_ptr [queue_id]->pk_list_ptr);
				    			op_stat_write (stat_info_ptr->buffer_usage_in_pk_stathandle, q_size);
								op_stat_write (stat_info_ptr->buffer_usage_in_bytes_stathandle, qm_info->queue_info_ptr [queue_id]->current_queue_size_in_bytes);
								op_stat_write (interface_buffer_size_stathandle, qm_info->current_buffer_size);
				
								/* If RED/WRED is enabled, write a statistic for the average queue size.	*/
								if (qm_info->attributes_ptr->queue_configuration [queue_id]->red_status != 0)
									{
									op_stat_write (stat_info_ptr->red_average_queue_size_stathandle,
													qm_info->queue_info_ptr[queue_id]->average_queue_size);
				            	    }
								}
							} /* else insert_ok = OPC_FALSE */
						} /* else procesoor_busy = OPC_FALSE */
					} /* else interface_table_size = 0 */
				
				/* Statistics are not written when the statistic dimension is exceeded.	*/
				if (shared_mem_ptr->statistic_index < IP_DIM_STAT_INDEX_MAX)		
					{
					/* Write out a new data point for the "Traffic Received" statistic	*/
					/* under the 'IP Interface' group.											*/
					op_stat_write (stat_info_ptr->traffic_received_in_pps_stathandle, 1.0);
					op_stat_write (stat_info_ptr->traffic_received_in_bps_stathandle, pk_size);
				
					/* Write out a zero value to signal the end of the duration to hold */
					/* the statistic at the previously written out value.				*/
					op_stat_write (stat_info_ptr->traffic_received_in_pps_stathandle, 0.0);
					op_stat_write (stat_info_ptr->traffic_received_in_bps_stathandle, 0.0);
					}
				}


			/** state (enqueue) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "enqueue", "ip_output_iface_VC1 () [enqueue exit execs]")
				{
				}


			/** state (enqueue) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "enqueue", "idle")
				/*---------------------------------------------------------*/



			/** state (extract) enter executives **/
			FSM_STATE_ENTER_FORCED (1, state1_enter_exec, "extract", "ip_output_iface_VC1 () [extract enter execs]")
				{
				/** A packet has just been transmitted. We check now if there are other	**/
				/** packets in the output queues of this interface. If it is the        **/
				/** casee another packet is started transtimtting sice the link is free.**/
				/** The packet being transmitted is taken off the queue. A interrupt is	**/
				/** scheduled to indicate the end of the transmission and then the		**/
				/** is definitevely sent to the lower layers.							**/
				
				/* Get the queue from where the previous packet has just been sent.	     */
				queue_id = qm_info->queue_to_service;
				   
				/* If the queuing scheme is Virtualclock	  */
				if ( queuing_processing_scheme == IpC_VC_Queuing )
					{
					/* Check whether statistics have been registered for the queue. If    */
					/* not statistics will all be registered for the current queue.		  */
					stat_info_ptr = op_prg_list_access (stat_info_list_ptr, queue_id);
					stat_info_ptr->stat_is_registered == OPC_TRUE;
					if (stat_info_ptr->stat_is_registered == OPC_FALSE)
						{
						 output_iface_stats_register (queue_id);
						}
						
					/* Get the ICI of the packet.	*/
					qos_ici_ptr = op_pk_ici_get (sending_packet_ptr);
					op_ici_attr_get (qos_ici_ptr, "virtual_clock_stamp", &virtual_clock_stamp);
					op_ici_attr_get (qos_ici_ptr, "a_virtual_clock_stamp", &a_virtual_clock_stamp);
					
					/*  Write a value for the statistics Sending Virtual Clock stamp and    */
					/*  Sending Auxilary Virtual Clock Stamp.								*/
				   	op_stat_write (stat_info_ptr->virt_clock_stamp_stathandle, virtual_clock_stamp);
					op_stat_write (stat_info_ptr->a_virt_clock_stamp_stathandle, a_virtual_clock_stamp);
				
					
					}
				
				/* Sends the packet.	*/
				output_iface_packet_send (queue_id);
				
				/* Set some parameters for the WFQ algorithm. When RSVP is	*/
				/* enabled this queue can be deleted dybamically during the	*/
				/* processing.												*/
				if ((queuing_processing_scheme == IpC_WFQ_Queuing) && (qm_info->queue_to_service != QUEUE_DELETED_BY_RSVP))
					{
					/* Update the virtual time and real time, which need	*/
					/* to be updated each time a packet enter or leaves		*/
					/* the system.											*/
					qm_info->last_virtual_time = qm_info->queue_info_ptr[queue_id]->previous_time;
					qm_info->last_real_time = op_sim_time ();
				
					/* Update the virtual_time, which will be used later in	*/
					/* WFQ equation.										*/
					if (op_prg_list_size (qm_info->queue_info_ptr[queue_id]->pk_list_ptr) == 0)
				    	{
				    	qm_info->total_active_weight = qm_info->total_active_weight - qm_info->attributes_ptr->queue_configuration[queue_id]->weight;
				    	}
					}
				
				/* If there are still some packets in the output interface then	*/
				/* send one out, otherwise go back to idle state after defining	*/
				/* the processor as idle.										*/
				
				if (qm_info->curr_total_no_buf_pkts != 0)
					{
				   	/* Select the queue to service depending on the	*/
					/* the queuing processing mechanism.			*/
					switch (queuing_processing_scheme)
						{
						case IpC_FIFO_Queuing:
							{
							/* There is only one queue in FIFO.	*/
							queue_id = 0;
							break;
							}
				
						case IpC_WFQ_Queuing:
							{
							queue_id = Oms_Qm_Next_Wfq_Queue_Select (qm_info);
							break;
				        	}
						case IpC_VC_Queuing:
							{
							/* Loop through all the queues to find a queue with lowest  Auxilary Virtual Clock value */
							queue_id = -1;
							do
								{
								queue_id ++;
								}
							
							while ((op_prg_list_size (qm_info->queue_info_ptr[queue_id]->pk_list_ptr) == 0));
							
							/* Access the packet at the head of the queue.				 */
							/* Get the ICI of the packet at the head of the queue.		 */
							/* Get the Auxilary Virtual Clock stamp of the packet at the */
							/* head of the queue from the ICI.							 */
							
							packetptr = op_prg_list_access (qm_info->queue_info_ptr[queue_id]->pk_list_ptr, OPC_QPOS_HEAD);
							qos_ici_ptr = op_pk_ici_get (packetptr);
							op_ici_attr_get (qos_ici_ptr, "a_virtual_clock_stamp", &a_virtual_clock_stamp);
							
							min = a_virtual_clock_stamp;
							min_vc_q_index = queue_id;
							
							for (queue_id = 0; queue_id < qm_info->attributes_ptr->no_queues; queue_id++)
								{
								if ((op_prg_list_size (qm_info->queue_info_ptr[queue_id]->pk_list_ptr) != 0 ))
									{
									
									packetptr = op_prg_list_access (qm_info->queue_info_ptr[queue_id]->pk_list_ptr, OPC_QPOS_HEAD);
							        qos_ici_ptr = op_pk_ici_get (packetptr);
							        op_ici_attr_get (qos_ici_ptr, "a_virtual_clock_stamp", &a_virtual_clock_stamp);
								    if ( a_virtual_clock_stamp < min )
										{
										min = a_virtual_clock_stamp;
										min_vc_q_index = queue_id;
										}
				
									 }
								} /* end of for */
							
							/* Loop through all the queus to find out if there are more than one queue with */
							/* the same min Auxilary Virtual Clock. Then fill out the array that contains   */	 
							/* the index of the queus with minimum equal Auxilary Virtual Clock             */
							for ( queue_id = 0; queue_id < qm_info->attributes_ptr->no_queues; queue_id++)
								{
								if ( op_prg_list_size (qm_info->queue_info_ptr[queue_id]->pk_list_ptr) != 0 )
									{
									
									packetptr = op_prg_list_access (qm_info->queue_info_ptr[queue_id]->pk_list_ptr, OPC_QPOS_HEAD);
							        qos_ici_ptr = op_pk_ici_get (packetptr);
							        op_ici_attr_get (qos_ici_ptr, "a_virtual_clock_stamp", &a_virtual_clock_stamp);
								    if ( min == a_virtual_clock_stamp )
										{
										j = 0;
										no_eqvc_queues =  0;
										active_q_index[j] =  queue_id;
										j++;
										no_eqvc_queues++;
										}
									}
								}
							 if ( no_eqvc_queues>1 )
								 {
								 queue_id = active_q_index[0];
								 }
							 else
								 {
								 queue_id = min_vc_q_index;
								 }	
							break;
							}
				
						
						case IpC_Priority_Queuing:
							{
							queue_id = Oms_Qm_Next_Pq_Queue_Select (qm_info);
							break;
							}
				
						case IpC_Custom_Queuing:
							{
							queue_id = Oms_Qm_Next_Cq_Queue_Select (qm_info, queue_id, &current_byte_count);
							break;
							}
				
						default:
							{
							/* No queuing processing has been chosen.	*/
							output_iface_warning_message_print ("Unknown Queuing scheme has been chosen");
							}
				        }
				
					/* Calculate the time it will take to process the packet.	*/
					time_to_service = Oms_Qm_Service_Time_Get (queue_id, qm_info);
				
					/* Schedule an interrupt. The interrupt code is	*/
					/* the output queue on this interface.			*/
					op_intrpt_schedule_self (op_sim_time () + time_to_service, queue_id);
					
					
					
					
					
					
					
					
					/* We extract the packet at head of the queue.	*/
					sending_packet_ptr = Oms_Qm_Packet_Extract (queue_id, qm_info);
				
					/* Update the current byte count for Custom Queuing.	*/
					if (queuing_processing_scheme == IpC_Custom_Queuing)
						{
						current_byte_count = current_byte_count + (int) (op_pk_total_size_get (sending_packet_ptr) / 8);
				        }
				
					/* Write statistic for buffer usage.	*/
					stat_info_ptr = op_prg_list_access (stat_info_list_ptr, queue_id);
					q_size = op_prg_list_size (qm_info->queue_info_ptr [queue_id]->pk_list_ptr);
				
					/* Statistics are not written when the statistic dimension is exceeded.	*/
					if (shared_mem_ptr->statistic_index < IP_DIM_STAT_INDEX_MAX)		
						{
					    op_stat_write (stat_info_ptr->buffer_usage_in_pk_stathandle, q_size);
						op_stat_write (stat_info_ptr->buffer_usage_in_bytes_stathandle, qm_info->queue_info_ptr [queue_id]->current_queue_size_in_bytes);
						op_stat_write (interface_buffer_size_stathandle, qm_info->current_buffer_size);
						}
				
					/* Store the queue being serviced.	*/
					qm_info->queue_to_service = queue_id;
				
					if (LTRACE_QM)
						{
				         sprintf (disp_string1, "Packet %d Transmission Starts on Interface %d Queue %d", op_pk_id (sending_packet_ptr), interface_info_ptr->addr_index, queue_id);
						op_prg_odb_print_minor (disp_string1, OPC_NIL);
						}
				
					/* Mark the processor of the interface as busy now	*/
					processor_busy = OPC_TRUE;
				  	} /* End of there exists some packets in the interface */
				else
					{
				   	/*  All queues are empty.	     		*/
					/*  Mark the processor as idle.			*/
					processor_busy = OPC_FALSE;
				
					/* Set the byte count to zero for the next	*/
					/* custom queue, which will serve packets.	*/
					if (queuing_processing_scheme == IpC_Custom_Queuing)
						current_byte_count = 0;
				
					/* Set some parameters for the WFQ algorithm.	*/
					if (queuing_processing_scheme == IpC_WFQ_Queuing)
						{
						/* Virtual time is defined to be zero for all	*/
						/* times when the processor is idle.			*/
						qm_info->last_virtual_time = 0;
				
						/* Loop through all the queues to initialize the previous	*/
						/* finish time.												*/
						for (q_index = 0; q_index < qm_info->attributes_ptr->no_queues; q_index++)
							{
							qm_info->queue_info_ptr[q_index]->previous_time = 0.0;
							}
						}
				
					/* Keeps the last idle time for RED to compute the average queue size.	*/
					if (qm_info->attributes_ptr->queue_configuration [queue_id]->red_status != 0)
						{
						qm_info->queue_info_ptr[queue_id]->start_idle_time = op_sim_time ();
				        }
				
					/* Set the queue to service to unassigned.	*/
					qm_info->queue_to_service = -1;
				
					/* Set buffer size to zero for round off.	*/
					qm_info->queue_info_ptr[queue_id]->current_queue_size_in_bytes = 0.0;
					qm_info->current_buffer_size = 0.0;
					}
				}


			/** state (extract) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "extract", "ip_output_iface_VC1 () [extract exit execs]")
				{
				}


			/** state (extract) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "extract", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (2, state2_enter_exec, "idle", "ip_output_iface_VC1 () [idle enter execs]")
				{
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (5,ip_output_iface_VC1)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (2, "idle", "ip_output_iface_VC1 () [idle exit execs]")
				{
				/** Definition of a tag to know if the interrupt come from the child itself		**/
				/** or from the root process. If it comes from the root process with no ICI, it	**/
				/** means a packet is arriving so we enter into the enqueue state. If an ICI is	**/
				/** associated with the interrupt, this is a RSVP request. Depending on the		**/
				/** call type, we enter one of the RSVP states. Otherwise this is a self		**/
				/** interrupt, so we enter in the extract state.								**/
				
				/* Check the shared memory with IP to know whether	*/
				/* the invokation is a RSVP request or not.			*/
				rsvp_parameters_ptr = shared_mem_ptr->rsvp_request_ptr;
				if (rsvp_parameters_ptr != OPC_NIL)
					{
					/* Unset the RSVP request in shared memory for next invokation.	*/
					shared_mem_ptr->rsvp_request_ptr = OPC_NIL;
				
					/* Get the RSVP call type associated with this request.		*/
					rsvp_call_type = rsvp_parameters_ptr->call_type;
					}
				else
					{
					/* There is no RSVP request associated with the interrupt.	*/
					/* A data packet is coming from the root process.			*/
					rsvp_call_type = OPC_INT_INVALID;
					}
				
				/* get the origin of the interrupt: the root process or the child process.	*/
				op_pro_invoker (op_pro_self (), &invocation_mode);
				
				
				
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (RECEIVE_PACKET)
			FSM_TEST_COND (SEND_PACKET)
			FSM_TEST_COND (CREATE_RSVP_QUEUE)
			FSM_TEST_COND (MODIFY_RSVP_QUEUE_PARAMS)
			FSM_TEST_COND (DELETE_RSVP_QUEUE)
			FSM_TEST_COND (ADD_RSVP_SENDER)
			FSM_TEST_COND (DELETE_RSVP_SENDER)
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;, "RECEIVE_PACKET", "", "idle", "enqueue")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "SEND_PACKET", "", "idle", "extract")
				FSM_CASE_TRANSIT (2, 5, state5_enter_exec, ;, "CREATE_RSVP_QUEUE", "", "idle", "create_rsvp_queue")
				FSM_CASE_TRANSIT (3, 4, state4_enter_exec, ;, "MODIFY_RSVP_QUEUE_PARAMS", "", "idle", "modify_rsvp_queue")
				FSM_CASE_TRANSIT (4, 6, state6_enter_exec, ;, "DELETE_RSVP_QUEUE", "", "idle", "delete_rsvp_queue")
				FSM_CASE_TRANSIT (5, 7, state7_enter_exec, ;, "ADD_RSVP_SENDER", "", "idle", "add_rsvp_sender")
				FSM_CASE_TRANSIT (6, 8, state8_enter_exec, ;, "DELETE_RSVP_SENDER", "", "idle", "delete_rsvp_sender")
				}
				/*---------------------------------------------------------*/



			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (3, "init", "ip_output_iface_VC1 () [init enter execs]")
				{
				/** This state initializes the variables and structure qm_info			**/
				/** used  by the child process.	The qm_info structure is configured		**/
				/** per interface. It contains general information like the maximum 	**/
				/** number of packets in the queues, the number of queues in the 		**/
				/** interface, the service rate of the processor and also the lists 	**/
				/** of packets.															**/
				
				/* Get the information about the interfaces (number of queues, 		*/
				/* outstreams...) in the memory shared with the IP process model.	*/
				shared_mem_ptr = op_pro_parmem_access ();
				interface_table_ptr = shared_mem_ptr->iface_table_ptr;
				
				/* Get the number of connected interfaces.	*/
				interface_table_size = op_prg_list_size (interface_table_ptr);
				
				/* Get the interface index for this child process.			*/
				/* This interface index won't change during the simulation.	*/
				interface_index = shared_mem_ptr->iface_index;
				
				/* Get a data structure containing information about the	*/
				/* interface, such as outstream, speed,...					*/
				interface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, interface_index);
				
				/* If the access to the data structure fails the simulation ends.	*/
				if (interface_info_ptr == OPC_NIL)
					{
					op_sim_end ("Unable to access the interface list", "", "", "");
					}
				
				/* Get the outgoing stream for this child process.			*/
				/* This outstream will be constant though the simulation.	*/
				outstrm = interface_info_ptr->port_num;
				
				/* Get the queuing scheme for this interface such as FIFO,	*/
				/* WFQ, Priority Queuing or Custom Queuing.					*/
				queuing_processing_scheme = interface_info_ptr->queuing_scheme;
				
				if ((output_iface_rsvp_is_enabled () == OPC_TRUE) && 
					((queuing_processing_scheme == IpC_Custom_Queuing) || (queuing_processing_scheme == IpC_WFQ_Queuing)))
					{
					/* Initialization of the structure qm_info.	*/
					qm_info = Oms_Qm_Info_Create (interface_info_ptr->addr_index, 
												interface_info_ptr->speed, ip_qos_with_rsvp_info_assign);
				
					/* Set RSVP flag to enabled.	*/
					qm_info->rsvp_flag = OPC_TRUE;
				
					/* Since RSVP is enabled, set the queuing processing	*/
					/* mechanism to WFQ if the original queuing mechanism	*/
					/* is not WFQ or priority queuing.						*/
					if (queuing_processing_scheme == IpC_Custom_Queuing)
						{
						qm_info->total_weight = qm_info->attributes_ptr->queue_configuration[0]->byte_count_number;
						}
					else
						{
						queuing_processing_scheme 	= 	IpC_WFQ_Queuing;
						qm_info->total_weight		=	qm_info->attributes_ptr->queue_configuration[0]->weight;
				        }
				
					/* Register statistic for allocated bandwidth by RSVP protocol.	*/
					rsvp_allocated_bandwidth_stathandle = op_stat_reg ("IP Interface.RSVP Allocated Bandwidth", shared_mem_ptr->rsvp_statistic_index, OPC_STAT_LOCAL);
					sprintf (new_name, "RSVP Allocated Bandwidth (bytes/sec)IF%d", interface_info_ptr->addr_index);
					op_stat_rename (rsvp_allocated_bandwidth_stathandle, new_name);
				
					/* Register statistic for allocated buffer by RSVP protocol.	*/
					rsvp_allocated_buffer_stathandle = op_stat_reg ("IP Interface.RSVP Allocated Buffer", shared_mem_ptr->rsvp_statistic_index, OPC_STAT_LOCAL);
					sprintf (new_name, "RSVP Allocated Buffer (bytes) IF%d", interface_info_ptr->addr_index);
					op_stat_rename (rsvp_allocated_buffer_stathandle, new_name);
				
					/* Register statistic for buffer size in bytes per interface.	*/
					interface_buffer_size_stathandle = op_stat_reg ("IP Interface.Total Buffer Size (bytes)", shared_mem_ptr->rsvp_statistic_index, OPC_STAT_LOCAL);
					sprintf (new_name, "Total Buffer Size (bytes) IF%d", interface_info_ptr->addr_index);
					op_stat_rename (interface_buffer_size_stathandle, new_name);
				
					/* Increment the index to these statistic handles. Many interfaces	*/
					/* are using the same statistic name.								*/
					shared_mem_ptr->rsvp_statistic_index ++;
				
					/* Initialize the allocated buffer size and allocated bandwidth.	*/
					rsvp_allocated_buffer 		= 0;
					rsvp_allocated_bandwidth 	= 0.0;
					}
				else
					{
					/* Initialization of the structure qm_info.	*/
					qm_info = Oms_Qm_Info_Create (interface_info_ptr->addr_index, 
												interface_info_ptr->speed, ip_qos_info_assign);
				
					/* Set RSVP flag to disabled.	*/
					qm_info->rsvp_flag = OPC_FALSE;
				
					/* Register statistic for buffer size in bytes per interface.	*/
					interface_buffer_size_stathandle = op_stat_reg ("IP Interface.Total Buffer Size (bytes)", shared_mem_ptr->rsvp_statistic_index, OPC_STAT_LOCAL);
					sprintf (new_name, "Total Buffer Size (bytes) IF%d", interface_info_ptr->addr_index);
					op_stat_rename (interface_buffer_size_stathandle, new_name);
				
					/* Increment the index to these statistic handles. Many interfaces	*/
					/* are using the same statistic name.								*/
					shared_mem_ptr->rsvp_statistic_index ++;
					}
				
				/* Create the statistic list for all queues.	*/
				stat_info_list_ptr = op_prg_list_create ();
				
				/* Loop through all the queues to indicate that the statistics have		*/
				/* not been registered yet. Later, only queues that are used will be	*/
				/* registered and contain valid statistic data.							*/
				for (q_index = 0; q_index < qm_info->attributes_ptr->no_queues; q_index++)
					{
					/* Initialization of the stathandles array. This element contains	*/
					/* stathandles for buffer size, traffic sent/received/dropped		*/
					/* for this queue.													*/
					if ((stat_info_ptr = (OmsT_Qm_Stat_Info*) 
						op_prg_mem_alloc (sizeof (OmsT_Qm_Stat_Info))) == OPC_NIL)
						{
						/* Stop the simulation if there is no memory available for	*/
						/* statistic handles.										*/
						output_iface_warning_message_print ("Unable to allocate memory for Statistic information");
						}
				
					/* Set the queue stathandle as not registered. They will	*/
					/* be registered only if the queue receives a packet.		*/
					stat_info_ptr->stat_is_registered = OPC_FALSE;
				
					/* Insert the queue stathandles in the interface stathandle list.	*/
					op_prg_list_insert (stat_info_list_ptr, stat_info_ptr, q_index);
				   	}
				
				/* Initialization of the "processor" (idle). There is one processor per interface.	*/
				/* The packets are scheduled at the link rate. The flag processor control			*/
				/* whether a packet is being transmitted. The flag is set if a packet can not		*/
				/* be tranmitted and unset if a packet can be transmitted.							*/
				processor_busy = OPC_FALSE;
				
				/* Initialize handles for notification handles.	*/
				ip_qos_notif_log_handles_init ();
				warning_pk_dropped_message_printed = OPC_FALSE;
				warning_frag_message_print = OPC_FALSE;
				
				/* Create an ICI for ARP. This ICI will send the next	*/
				/* address and the connection class.					*/
				if ((arp_ici_ptr = op_ici_create ("ip_arp_req_v4")) == OPC_NIL)
					{
					op_sim_end ("Unable to create an ICI for communicating with ARP.", "", "", "");
				    }     
				
				/* Write a notification log if background traffic is used. Background traffic	*/
				/* is not compatible with the use of a output queuing mechanism such FIFO, WFQ,	*/
				/* Priority Queuing or Custom Queuing.											*/
				if (op_tim_init() != OPC_COMPCODE_FAILURE) 
					wfqnl_configwarn_use_bg_traffic ();      
					
				/* Set the current byte count to zero in case if Custom	Queuing is used.	*/
				current_byte_count = 0;
				
				/* Indicate that the IP output Interface process has been initialized.		*/
				is_output_initialized = OPC_TRUE;
				
				/* Indicated wheter a queue has to be deleted.	*/
				queue_to_be_deleted = OPC_FALSE;
				
				
					
				
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "init", "ip_output_iface_VC1 () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (modify_rsvp_queue) enter executives **/
			FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "modify_rsvp_queue", "ip_output_iface_VC1 () [modify_rsvp_queue enter execs]")
				{
				/** Modify queue parameters (buffer size, bandwidth allocation).	**/
				/** WFQ gets RSVP call parameters ( Call_type, Session_ptr and		**/
				/** Tspec_ptr). WFQ returns Call_status to tell RSVP whether the	**/
				/** allocation went though.											**/
				
				/* Get the index of the queue to be modified.	*/
				for (q_index = 0; q_index < qm_info->attributes_ptr->no_queues; q_index++)
					{
					if (qm_info->queue_info_ptr[q_index]->pk_list_ptr == rsvp_parameters_ptr->tc_handle)
						{
						break;
						}
					}
				
				/* Check whether the queue exists. Aborts the RSVP modification request if not.	*/
				if ((q_index != qm_info->attributes_ptr->no_queues) && (qm_info->rsvp_flag == OPC_TRUE))
					{
					/* Change the total amount of weight.	*/
					switch (queuing_processing_scheme)
						{
						case IpC_WFQ_Queuing:
							{
							qm_info ->total_weight -= qm_info->attributes_ptr->queue_configuration [q_index]->weight;
				            break;
							}
				
						case IpC_Custom_Queuing:
							{
							qm_info ->total_weight -= qm_info->attributes_ptr->queue_configuration [q_index]->byte_count_number;
							break;
							}
				
						default:
							/* RSVP is supposed to work with WFQ or custom queuing.	*/
							output_iface_warning_message_print ("WFQ or Custom Queuing should be enabled for RSVP.");
						}
				
					/* Get the new weight to conform the required bandwidth allocation.	*/
					weight = output_iface_new_weight_get ();
				
					/* Check whether there is enough bandwidth for the new allocation.	*/
					if (weight == IP_IFACE_INSUFF_WEIGHT)
						{
						/* The allocation of bandwidth failed. Set back the original weight.	*/
						switch (queuing_processing_scheme)
							{
							case IpC_WFQ_Queuing:
								{
								qm_info ->total_weight += qm_info->attributes_ptr->queue_configuration [q_index]->weight;
				    	        break;
								}
							case IpC_Custom_Queuing:
								{
								qm_info ->total_weight += qm_info->attributes_ptr->queue_configuration [q_index]->byte_count_number;
								break;
								}
							}
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the queue creation failed.								*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue parameters modification failed", OPC_NIL);
							}
						}
					else
						{
						/* Write a statistic to keep track of the buffer size allocated	*/
						/* on this interface.											*/
						op_stat_write (rsvp_allocated_buffer_stathandle, rsvp_allocated_buffer);
						rsvp_allocated_buffer = rsvp_allocated_buffer - qm_info->attributes_ptr->queue_configuration[q_index]->max_size + rsvp_parameters_ptr->tspec_ptr->bucket_size;
						op_stat_write (rsvp_allocated_buffer_stathandle, rsvp_allocated_buffer);
					
						/* The allocation succeeded. Change the weight and the buffer size.	*/
						switch (queuing_processing_scheme)
							{
							case IpC_WFQ_Queuing:
								{
								/* Write a statistic to keep track of the bandwidth allocated	*/
								/* on this interface.											*/
								op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
								rsvp_allocated_bandwidth = rsvp_allocated_bandwidth - qm_info->attributes_ptr->queue_configuration [q_index]->rsvp_reserved_bandwidth + rsvp_parameters_ptr->tspec_ptr->bucket_rate;
								qm_info->attributes_ptr->queue_configuration [q_index]->rsvp_reserved_bandwidth = rsvp_parameters_ptr->tspec_ptr->bucket_rate;
								op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
				
								/* Change the queue parameters as requested by RSVP.	*/
								qm_info->attributes_ptr->queue_configuration [q_index]->weight		= 	weight;
								qm_info->attributes_ptr->queue_configuration [q_index]->max_size 	= 	rsvp_parameters_ptr->tspec_ptr->bucket_size;
								break;
								}
							case IpC_Custom_Queuing:
								{
								/* Write a statistic to keep track of the bandwidth allocated	*/
								/* on this interface.											*/			
								op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
								rsvp_allocated_bandwidth = rsvp_allocated_bandwidth - qm_info->attributes_ptr->queue_configuration [q_index]->rsvp_reserved_bandwidth + rsvp_parameters_ptr->tspec_ptr->bucket_rate;
								qm_info->attributes_ptr->queue_configuration [q_index]->rsvp_reserved_bandwidth = rsvp_parameters_ptr->tspec_ptr->bucket_rate;
								op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
				
								/* Change the queue parameters as requested by RSVP.	*/
								qm_info->attributes_ptr->queue_configuration [q_index]->byte_count_number	= 	weight;
								qm_info->attributes_ptr->queue_configuration [q_index]->max_size			= 	rsvp_parameters_ptr->tspec_ptr->bucket_size;
								break;
								}
							}
				
						/* Update the total amount of weight already in use.	*/
						qm_info ->total_weight 	+= 	weight;
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the queue modification succeeded.						*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_SUCCESS;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue creation succeeded", OPC_NIL);
							}
						}
					}
				else
					{
					/* Set the call status field in ICI sent by RSVP to indicate	*/
					/* that the queue modification failed.							*/
					rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
				
					/* Writing traces for ODB.	*/
					if (LTRACE_RSVP)
						{
						op_prg_odb_print_major ("RSVP queue parameters modification failed", OPC_NIL);
				
						if (qm_info->rsvp_flag == OPC_FALSE)
							{
							op_prg_odb_print_minor ("RSVP is disabled on this interface.", OPC_NIL);
							}
						}
					}
				
				}


			/** state (modify_rsvp_queue) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "modify_rsvp_queue", "ip_output_iface_VC1 () [modify_rsvp_queue exit execs]")
				{
				}


			/** state (modify_rsvp_queue) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "modify_rsvp_queue", "idle")
				/*---------------------------------------------------------*/



			/** state (create_rsvp_queue) enter executives **/
			FSM_STATE_ENTER_FORCED (5, state5_enter_exec, "create_rsvp_queue", "ip_output_iface_VC1 () [create_rsvp_queue enter execs]")
				{
				/** Create a new RSVP queue upon request from		**/
				/** RSVP module sending a remote interrupt to IP.	**/
				/** To create a new queue, WFQ uses RSVP call		**/
				/** parameters (Call_type, Session_ptr, Tspec_ptr)	**/
				/** gotten from the shared memory.					**/
				/** WFQ will return Tc_handle and call status to	**/
				/** tell RSVP whether the reservation went through.	**/
				
				/* Get the current number of queues.	*/
				number_of_queues = qm_info->attributes_ptr->no_queues;
				
				/* Check whether there is enough bandwidth for the new queue.	*/
				/* The function returns either IP_IFACE_INSUFF_WEIGHT if there	*/
				/* is not enough bandwidth for the new queue, or the weight		*/
				/* to reserve the required bandwidth.							*/
				weight = output_iface_new_weight_get ();
				if ((weight != IP_IFACE_INSUFF_WEIGHT) && (qm_info->rsvp_flag == OPC_TRUE))
					{
					/* Set the configuration parameters for the new queue. These		*/
					/* parameters are the buffer capacity (burst size and the weight	*/
					/* which will determine the allocation of bandwidth for the RSVP	*/
					/* session.															*/
				
					/* Create a new queue configuration array with one more element.	*/
					/* This array will replace the previous queue configuration array.	*/
					new_queue_configuration_ptr = (OmsT_Qm_Queue_Configuration **) 
							op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration *) * (number_of_queues + 1));
					
					/* Copy the previous queue configuration array at the beginning of	*/
					/* the new queue configuration array.								*/
					op_prg_mem_copy (qm_info->attributes_ptr->queue_configuration, new_queue_configuration_ptr, 
							sizeof (OmsT_Qm_Queue_Configuration *) * number_of_queues);
				
					/* Allocate memory for the new queue configuration element to add	*/
					/* into the new queue configuration array.							*/
					new_queue_configuration_ptr [number_of_queues] = (OmsT_Qm_Queue_Configuration *) 
												op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));
				
					/* Store allocated bandwidth for later statistic record.	*/
					new_queue_configuration_ptr [number_of_queues]->rsvp_reserved_bandwidth = rsvp_parameters_ptr->tspec_ptr->bucket_rate;
					
					/* Initialize the new queue configuration element with the weight	*/
					/* required to allocate bandwidth as well as the buffer size.		*/
					switch (queuing_processing_scheme)
						{
						case IpC_WFQ_Queuing:
							{
							new_queue_configuration_ptr [number_of_queues]->weight 				= 	weight;
							new_queue_configuration_ptr [number_of_queues]->byte_count_number 	= 	0;
							break;
							}
						case IpC_Custom_Queuing:
							{
							new_queue_configuration_ptr [number_of_queues]->weight 				= 	0.0;
							new_queue_configuration_ptr [number_of_queues]->byte_count_number 	= 	weight;
							break;
							}
				
						default:
							/* RSVP is supposed to work with WFQ or custom queuing.	*/
							output_iface_warning_message_print ("WFQ or Custom Queuing should be enabled for RSVP.");
						}
				
					new_queue_configuration_ptr [number_of_queues]->max_size 			= 	rsvp_parameters_ptr->tspec_ptr->bucket_size;
					new_queue_configuration_ptr [number_of_queues]->red_status 			= 	OmsC_No_Red;
				
					/* Free the no more used memory of the previous queue configuration array.	*/
					op_prg_mem_free (qm_info->attributes_ptr->queue_configuration);	
				
					/* Replace the previous queue configuration array with the new one.	*/
					qm_info->attributes_ptr->queue_configuration = new_queue_configuration_ptr;
				
					/* Create and initialize a new array in charge of storing packets.	*/
					/* This array will contain a new storing queue element in addition	*/
					/* to the whole previous storing array.								*/	
				
					/* Create a new queue storing array with one more element.	*/
					new_queue_info_ptr = (OmsT_Qm_Queue_Info **) op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Info*) * (number_of_queues + 1));
				
					/* Copy the previous queue storing array at the beginning of	*/
					/* the new queue storing array.									*/
					op_prg_mem_copy (qm_info->queue_info_ptr, new_queue_info_ptr, sizeof (OmsT_Qm_Queue_Info*) * number_of_queues);
				
					/* Allocate memory for the new queue storing element to add	*/
					/* into the new queue storing array.						*/
					new_queue_info_ptr [number_of_queues] = (OmsT_Qm_Queue_Info *) op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Info));
				
					/* Initialize the new queue queue storing element.	*/ 
					new_queue_info_ptr [number_of_queues]->previous_time 		= 	0.0;
					new_queue_info_ptr [number_of_queues]->finish_time 			= 	OmsC_Uncomputed;
					new_queue_info_ptr [number_of_queues]->average_queue_size 	= 	0.0;
					new_queue_info_ptr [number_of_queues]->start_idle_time 		= 	0.0;
					new_queue_info_ptr [number_of_queues]->pk_list_ptr 			= 	op_prg_list_create ();
					new_queue_info_ptr [number_of_queues]->queue_to_delete		=	OPC_FALSE;
				
					/* Free the no more used memory of the previous queue storing array.	*/
					op_prg_mem_free (qm_info->queue_info_ptr);
				
					/* Replace the previous queue storing array with the new one.	*/
					qm_info->queue_info_ptr = new_queue_info_ptr;
				
					/* Set the classification scheme for this new queue. The classification	*/
					/* parameters are taken from the shared memory. The classification		*/
					/* includes the protocol type, the source and destination IP addresses	*/
					/* and the source and destination port numbers.							*/
				
					/* Allocate memory for the new classification scheme.	*/
					classification_element_ptr = (OmsT_Qm_Classification_Criteria *) op_prg_mem_alloc (sizeof (OmsT_Qm_Classification_Criteria));
				
					/* Initialize the new classification scheme.	*/
					classification_element_ptr->queue_id 			=	number_of_queues;
					classification_element_ptr->protocol 			= 	rsvp_parameters_ptr->session_ptr->protocol_id;
					classification_element_ptr->source_address		= 	IPC_ADDR_INVALID;
					classification_element_ptr->tos 				= 	OmsC_Unassigned;
					classification_element_ptr->source_port 		= 	OmsC_Unassigned;
					classification_element_ptr->incoming_iface 		= 	OmsC_Unassigned;
					classification_element_ptr->dest_address 		= 	ip_address_copy (rsvp_parameters_ptr->session_ptr->dest_address);
					classification_element_ptr->dest_port 			= 	rsvp_parameters_ptr->session_ptr->dest_port;
					classification_element_ptr->incoming_iface 		= 	OmsC_Unassigned;
				
					/* The new classification scheme is added to the classification list.	*/
					/* More classification schemes may be added later on.					*/
					op_prg_list_insert (qm_info->attributes_ptr->classification_list_ptr, classification_element_ptr, OPC_LISTPOS_TAIL);
				
					/* Set the new number of queues.	*/
					qm_info->attributes_ptr->no_queues++;
				
					/* Update the total sum of weight on this interface.	*/
					qm_info->total_weight += weight;
				
					/* Create a new element if there are not enough elements in the		*/
					/* queuing statistic list. These statistics are traffic received,	*/
					/* traffic sent, traffic dropped, queue usage and queuing delay.	*/
					if (op_prg_list_size (stat_info_list_ptr) < number_of_queues + 1) 
						{
						/* Initialization of the stathandles list. This element contains	*/
						/* stathandles for buffer size, traffic sent/received/dropped		*/
						/* and queuing delay for this queue.								*/
						if ((stat_info_ptr = (OmsT_Qm_Stat_Info*) 
							op_prg_mem_alloc (sizeof (OmsT_Qm_Stat_Info))) == OPC_NIL)
							{
							/* Stop the simulation if there is no memory available for	*/
							/* statistic handles.										*/
							output_iface_warning_message_print ("Unable to allocate memory for Statistic information");
							}
				
						/* Set the queue stathandle as not registered. They will	*/
						/* be registered only if the queue receives a packet.		*/
						stat_info_ptr->stat_is_registered = OPC_FALSE;
				
						/* Insert the queue stathandles in the interface stathandle list.	*/
						op_prg_list_insert (stat_info_list_ptr, stat_info_ptr, number_of_queues);
						}
				
					/* Write a statistic to keep track of the bandwidth allocated	*/
					/* on this interface.											*/
					op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
					rsvp_allocated_bandwidth += rsvp_parameters_ptr->tspec_ptr->bucket_rate;
					op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
				
					/* Write a statistic to keep track of the buffer size allocated	*/
					/* for this interface.											*/
					op_stat_write (rsvp_allocated_buffer_stathandle, rsvp_allocated_buffer);
					rsvp_allocated_buffer += rsvp_parameters_ptr->tspec_ptr->bucket_size;
					op_stat_write (rsvp_allocated_buffer_stathandle, rsvp_allocated_buffer); 
				
					/* Set the call status field in ICI sent by RSVP to indicate	*/
					/* that the queue creation succeeded.							*/
					rsvp_parameters_ptr->call_status = OPC_COMPCODE_SUCCESS;
				
					/* Send also to RSVP an handle to the new queue. This handle	*/
					/* will then be used to delete or modify the queue.				*/
					rsvp_parameters_ptr->tc_handle = qm_info->queue_info_ptr [number_of_queues]->pk_list_ptr;
				
					/* Writing traces for ODB.	*/
					if (LTRACE_RSVP)
						{
						op_prg_odb_print_major ("RSVP queue creation succeeded", OPC_NIL);
						}
					}
				else
					{
					/* Set the call status field in ICI sent by RSVP to indicate	*/
					/* that the queue creation failed.								*/
					rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
					rsvp_parameters_ptr->tc_handle = OPC_NIL;
				
					/* Writing traces for ODB.	*/
					if (LTRACE_RSVP)
						{
						op_prg_odb_print_major ("RSVP queue creation failed", OPC_NIL);
				
						if (qm_info->rsvp_flag == OPC_FALSE)
							{
							op_prg_odb_print_minor ("RSVP is disabled on this interface.", OPC_NIL);
							}
						}
					}
				}


			/** state (create_rsvp_queue) exit executives **/
			FSM_STATE_EXIT_FORCED (5, "create_rsvp_queue", "ip_output_iface_VC1 () [create_rsvp_queue exit execs]")
				{
				}


			/** state (create_rsvp_queue) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "create_rsvp_queue", "idle")
				/*---------------------------------------------------------*/



			/** state (delete_rsvp_queue) enter executives **/
			FSM_STATE_ENTER_FORCED (6, state6_enter_exec, "delete_rsvp_queue", "ip_output_iface_VC1 () [delete_rsvp_queue enter execs]")
				{
				/** Delete a RSVP queue upon RSVP request. WFQ gets RSVP parameters (Call_type and	**/
				/** TC_handle) from shared memory with IP and returns Call_status to indicate if	**/
				/** the deletion went through.														**/
				
				/* Get the total number of queues on this interface.	*/
				number_of_queues = qm_info->attributes_ptr->no_queues;
				
				/* get the origin of the interrupt: the root process or the child process.	*/
				op_pro_invoker (op_pro_self (), &invocation_mode);
				
				if ((queue_to_be_deleted == OPC_FALSE) && (invocation_mode == OPC_PROINV_INDIRECT))
					{
					/* Get the index of the queue to be deleted thanks to the TC_handle gotten from	*/
					/* the shared memory. Loop though all the existing queues to find the matching	*/
					/* queue to be deleted. If there is no match, the deletion will be said to have	*/
					/* failed (Call_status).														*/	
					for (q_index = 0; q_index < number_of_queues; q_index++)
						{
						/* Compare the queue pointer received from RSVP to a existing queue pointer.	*/
						if ((qm_info->queue_info_ptr[q_index]->pk_list_ptr) ==  ((List*) rsvp_parameters_ptr->tc_handle))
							{
							/* The queue to delete has been found. Update the total sum of weight	*/
							/* and write a statistic for reserved bandwidth.						*/
				
							/* Check first whether this queue is empty. If the queue is empty it	*/
							/* will be immediately deleted. If not, the queue will be deleted when	*/
							/* the queue will get empty.											*/
							if (op_prg_list_size (qm_info->queue_info_ptr[q_index]->pk_list_ptr) != 0)
								{
								if (LTRACE_RSVP)
									{
									sprintf (disp_string1, "The RSVP queue to delete has %d packets\n", op_prg_list_size (qm_info->queue_info_ptr[q_index]->pk_list_ptr));
									op_prg_odb_print_major (disp_string1, OPC_NIL);
									}
				
								/* Set the flag on the queue in order to delete the queue as soon	*/
								/* as the queue will be empty.										*/
								qm_info->queue_info_ptr[q_index]->queue_to_delete = OPC_TRUE;
								}
				
							switch (queuing_processing_scheme)
								{
								case IpC_WFQ_Queuing:
									{
									qm_info ->total_weight -= qm_info->attributes_ptr->queue_configuration [q_index]->weight;
				
									/* Write a statistic to keep track of the bandwidth allocated	*/
									/* for this interface.											*/
									op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
									
									rsvp_allocated_bandwidth -= qm_info->attributes_ptr->queue_configuration [q_index]->rsvp_reserved_bandwidth;
				
									op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
				
						            break;
									}
				
								case IpC_Custom_Queuing:
									{
									qm_info ->total_weight -= qm_info->attributes_ptr->queue_configuration [q_index]->byte_count_number;
				
									/* Write a statistic to keep track of the bandwidth allocated	*/
									/* for this interface.											*/
									op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
									
									rsvp_allocated_bandwidth -= qm_info->attributes_ptr->queue_configuration [q_index]->rsvp_reserved_bandwidth;
									
									op_stat_write (rsvp_allocated_bandwidth_stathandle, rsvp_allocated_bandwidth);
				
									break;
									}
				
								default:
									/* RSVP is supposed to work with WFQ or custom queuing.	*/
									output_iface_warning_message_print ("WFQ or Custom Queuing should be enabled for RSVP.");
								}
				
							/* Stops the queue search.	*/
							break;
							}
						}
					}
				else
					{
					/* A queue needs to be deleted. A RSVP request came earlier.	*/
					/* Since the queue was not empty, the queue didn't get deleted.	*/
					/* The queue is now empty, so it can be deleted.				*/
					q_index = op_intrpt_code ();
				
					qm_info->queue_info_ptr[q_index]->queue_to_delete = OPC_FALSE;
					}
				
				/* Check if the queue to delete exists. Aborts the RSVP deletion request if not.	*/
				if ((q_index != number_of_queues) && (qm_info->rsvp_flag == OPC_TRUE) 
					&& (qm_info->queue_info_ptr[q_index]->queue_to_delete == OPC_FALSE) && (qm_info->queue_to_service != q_index))
					{
					/* Write a statistic to keep track of the buffer size allocated	*/
					/* for this interface.											*/
					op_stat_write (rsvp_allocated_buffer_stathandle, rsvp_allocated_buffer);
					rsvp_allocated_buffer -= qm_info->attributes_ptr->queue_configuration[q_index]->max_size;
					op_stat_write (rsvp_allocated_buffer_stathandle, rsvp_allocated_buffer);
				
					/* Create a new queue configuration array with one less element.	*/
					/* This array will replace the previous queue configuration array.	*/
					new_queue_configuration_ptr = (OmsT_Qm_Queue_Configuration **) op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration *) * (number_of_queues - 1));
				
					/* Copy the previous queue configuration array at the beginning of	*/
					/* the new queue configuration array up to the queue to delete.		*/
					op_prg_mem_copy (qm_info->attributes_ptr->queue_configuration, new_queue_configuration_ptr, sizeof (OmsT_Qm_Queue_Configuration *) * q_index);
				
					/* The queue configuration element to be deleted is taken off from	*/
					/* the new queue configuration array.								*/
					op_prg_mem_free (qm_info->attributes_ptr->queue_configuration [q_index]);
				
					/* Copy the other elements after the queue to delete in the new		*/
					/* queue configuration array.										*/
					for (queue_id = q_index; queue_id < number_of_queues-1; queue_id ++)
						{
						new_queue_configuration_ptr [queue_id] = qm_info->attributes_ptr->queue_configuration [queue_id+1];
						}
				
					/* Free the no more used memory of the previous queue configuration array.	*/
					op_prg_mem_free (qm_info->attributes_ptr->queue_configuration);
				
					/* Replace the previous queue configuration array with the new one.	*/
					qm_info->attributes_ptr->queue_configuration = new_queue_configuration_ptr;
				
					/* Create and initialize a new array in charge of storing packets.	*/
					/* This array will have a queue storing element less.				*/
				
					/* Create a new queue storing array with one less element.	*/
					new_queue_info_ptr = (OmsT_Qm_Queue_Info **) op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Info*) * (number_of_queues - 1));
					
					/* Copy the previous queue storing array at the beginning of	*/
					/* the new queue configuration array up to the queue to delete.	*/
					op_prg_mem_copy (qm_info->queue_info_ptr, new_queue_info_ptr, sizeof (OmsT_Qm_Queue_Info*) * q_index); 
				
					/* Update the current number of packets in the interface before deleting the queue.	*/
					deleted_queue_size = op_prg_list_size (qm_info->queue_info_ptr [q_index]->pk_list_ptr);
					qm_info->curr_total_no_buf_pkts -= deleted_queue_size;
				
					/* Loop through all the packets and destroy them.	*/
					for (packet_id = 0; packet_id < deleted_queue_size; packet_id ++)
						{
						/* Get the packet from the list.	*/
						pkptr = op_prg_list_access (qm_info->queue_info_ptr [q_index]->pk_list_ptr, OPC_LISTPOS_TAIL);
				
						/* Update the buffer size.	*/ 
						qm_info->current_buffer_size -= op_pk_total_size_get (pkptr) / 8;
				
						/* Destroy the packet.	*/
						op_pk_destroy (pkptr);	
						}
				
					/* The queue indexed by q_index is removed from the interface.	*/
					op_prg_list_free (qm_info->queue_info_ptr [q_index]->pk_list_ptr);
					op_prg_mem_free (qm_info->queue_info_ptr [q_index]->pk_list_ptr);
					op_prg_mem_free (qm_info->queue_info_ptr [q_index]);
				
					/* Copy the other elements after the queue to delete in the new		*/
					/* queue storing array.												*/
					for (queue_id = q_index; queue_id < number_of_queues-1; queue_id ++)
						{
						new_queue_info_ptr [queue_id] = qm_info->queue_info_ptr [queue_id+1];
						}
				
					/* Modify the next queue to service. If a queue is being processed	*/
					/* while deleting another queue, the index of the queue being		*/
					/* processed will change.											*/
					if (qm_info->queue_to_service == q_index)
						{
						qm_info->queue_to_service = QUEUE_DELETED_BY_RSVP;
						}
				
					/* If the next queue to service has a higher index than the deleted	*/
					/* queue, update the next queue to service index.					*/
					if (qm_info->queue_to_service > q_index)
						{
						qm_info->queue_to_service --;
						}
				
					/* Free the no more used memory of the previous queue storing array.	*/
					op_prg_mem_free (qm_info->queue_info_ptr);
				
					/* Replace the previous queue storing array with the new one.	*/
					qm_info->queue_info_ptr = new_queue_info_ptr;
				
					/* Delete the classification schemes for the deleted queue. The classification	*/
					/* parameters are taken from the interrupt ICI. The classification includes the */
					/* protocol type, the source and destination IP addresses and the source and 	*/
					/* destination port numbers.													*/
				
					/* Get the number of classification schemes.	*/
					number_of_schemes = op_prg_list_size (qm_info->attributes_ptr->classification_list_ptr);
				
				    /* Initialize the list index of the new classification list.	*/
					list_index = 0;
					
					/* Loop through all the classification schemes and delete the schemes	*/
					/* related to the queue to delete.										*/
					for (scheme_id = 0; scheme_id < number_of_schemes; scheme_id ++)
						{
						/* Get the classification scheme.	*/
						scheme_ptr = op_prg_list_access (qm_info->attributes_ptr->classification_list_ptr, list_index);
				
						/* check whether this classification scheme is related	*/
						/* to the queue to destroy.								*/
						if (scheme_ptr->queue_id == q_index)
							{
							/* Destroy the classification scheme if it related	*/
							/* to the queue to delete.							*/
							op_prg_list_remove (qm_info->attributes_ptr->classification_list_ptr, list_index);
							ip_address_destroy (scheme_ptr->source_address);
							op_prg_mem_free (scheme_ptr);
							}
						else
							{
				            /* Update the queue index for each element of the list whose	*/
							/* index is higher than the deleted queue index.				*/
							if (scheme_ptr->queue_id > q_index)
								{
				                /* Shift the index to the bottom.	*/
								scheme_ptr->queue_id--;
								}
							
							/* Update the list index of the current element.	*/
							list_index ++;
							}
						}
				
					/* Update the new number of queues after removing one queue.	*/
					qm_info->attributes_ptr->no_queues--;
				
					if (queue_to_be_deleted == OPC_FALSE)
						{
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the queue deletion succeeded.							*/
						/* The queue might not be deleted immediately if the queue is	*/
						/* not empty.													*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_SUCCESS;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue deletion succeeded", OPC_NIL);
							}
						}
					else
						{
						/* The queue was not deleted when RSVP made the request	*/
						/* because the queue was not full. Delete it now.		*/
						queue_to_be_deleted = OPC_FALSE;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP actual queue deletion succeeded", OPC_NIL);
							}
						}
					}
				else
					{
					if ((qm_info->queue_info_ptr[q_index]->queue_to_delete == OPC_TRUE) || (qm_info->queue_to_service == q_index))
						{
						/* The queue will be deleted later on. The queue is being serviced or	*/
						/* is not empty.														*/
						qm_info->queue_info_ptr[q_index]->queue_to_delete = OPC_TRUE;
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the queue deletion succeeded.							*/
						/* The queue might not be deleted immediately if the queue is	*/
						/* not empty.													*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_SUCCESS;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue deletion is postponed - queue not empty", OPC_NIL);
							}
						}
					else
						{
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the queue deletion failed.								*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue deletion failed", OPC_NIL);
				
							if (qm_info->rsvp_flag == OPC_FALSE)
								{
								op_prg_odb_print_minor ("RSVP is disabled on this interface.", OPC_NIL);
								}
							}
						}
				    }
				
				}


			/** state (delete_rsvp_queue) exit executives **/
			FSM_STATE_EXIT_FORCED (6, "delete_rsvp_queue", "ip_output_iface_VC1 () [delete_rsvp_queue exit execs]")
				{
				}


			/** state (delete_rsvp_queue) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "delete_rsvp_queue", "idle")
				/*---------------------------------------------------------*/



			/** state (add_rsvp_sender) enter executives **/
			FSM_STATE_ENTER_FORCED (7, state7_enter_exec, "add_rsvp_sender", "ip_output_iface_VC1 () [add_rsvp_sender enter execs]")
				{
				/** Add a sender to a RSVP queue. WFQ uses RSVP call parameters			**/
				/** (Call_type, Session_ptr and Tspec_ptr). WFQ returns Call_status		**/
				/** to indicate whether the RSVP modification went through.				**/
				
				/* Get the index of the queue to be modified.	*/
				for (q_index = 0; q_index < qm_info->attributes_ptr->no_queues; q_index++)
					{
					if (qm_info->queue_info_ptr[q_index]->pk_list_ptr == rsvp_parameters_ptr->tc_handle)
						{
						break;
						}
					}
				
				/* Check if the queue exists. Aborts the RSVP request if not.	*/
				if ((q_index != qm_info->attributes_ptr->no_queues) && (qm_info->rsvp_flag == OPC_TRUE))
					{
					/* Delete the classification scheme for this queue. The classification	*/
					/* parameters are taken from the shared memory. The classification		*/
					/* includes the protocol type, the source and destination IP addresses	*/
					/* and the source and destination port numbers.							*/
				
					/* Get the number of classification schemes.	*/
					number_of_schemes = op_prg_list_size (qm_info->attributes_ptr->classification_list_ptr);
				
					/* Loop through all the classification schemes to pick up the session parameters	*/
					/* of the queue to modify. Another classification scheme will be later created		*/
					/* with the same session parameters, but different sender.							*/
					for (scheme_id = 0; scheme_id < number_of_schemes; scheme_id ++)
						{
						/* Get the classification scheme.	*/
						scheme_ptr = op_prg_list_access (qm_info->attributes_ptr->classification_list_ptr, scheme_id);
				
						/* Stops the loop if the queue was found.	*/
						if (scheme_ptr->queue_id == q_index)
							{
							break;
							}
						}
				
					if (scheme_id == number_of_schemes)
						{
						/* There is no existing filter for this queue. A sender	*/
						/* can not be added unless a filter exists.				*/
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the queue modification failed.							*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
						}
					else
						{
						/* If no sender is specified for the scheme. Add one sender for this one.	*/
						/* If a sender exists, create a new classification scheme.					*/
						if ((scheme_ptr->source_address == IPC_ADDR_INVALID) && (scheme_ptr->source_port == OmsC_Unassigned))
							{
							scheme_ptr->source_address 	= 	ip_address_copy (rsvp_parameters_ptr->sender_ptr->sender_addr);
							scheme_ptr->source_port 	= 	rsvp_parameters_ptr->sender_ptr->sender_port;
				            }
						else
							{
							/* Allocate memory for the new classification scheme.	*/
							classification_element_ptr = (OmsT_Qm_Classification_Criteria *) op_prg_mem_alloc (sizeof (OmsT_Qm_Classification_Criteria));
				
							/* Set the new queue classification scheme.	*/
							classification_element_ptr->queue_id 		= 	q_index;
							classification_element_ptr->tos 			= 	OmsC_Qm_Tos_Unspecified;
							classification_element_ptr->protocol 		= 	scheme_ptr->protocol;
							classification_element_ptr->source_address 	= 	ip_address_copy (rsvp_parameters_ptr->sender_ptr->sender_addr);
							classification_element_ptr->dest_address 	= 	scheme_ptr->dest_address;
							classification_element_ptr->source_port 	= 	rsvp_parameters_ptr->sender_ptr->sender_port;
							classification_element_ptr->dest_port 		= 	scheme_ptr->dest_port;
							classification_element_ptr->incoming_iface 	= 	OmsC_Unassigned;
				
							/* The classification scheme is a list. More senders may be added later on.	*/
							op_prg_list_insert (qm_info->attributes_ptr->classification_list_ptr, classification_element_ptr, OPC_LISTPOS_TAIL);
							}
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the sender addition succeeded.							*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_SUCCESS;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue sender addition succeeded", OPC_NIL);
							}
						}
					}
				else
					{
					/* Set the call status field in ICI sent by RSVP to indicate	*/
					/* that the sender addition failed.								*/
					rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
				
					/* Writing traces for ODB.	*/
					if (LTRACE_RSVP)
						{
						op_prg_odb_print_major ("RSVP queue sender addition failed", OPC_NIL);
				
						if (qm_info->rsvp_flag == OPC_FALSE)
							{
							op_prg_odb_print_minor ("RSVP is disabled on this interface.", OPC_NIL);
							}
						}
					}
				}


			/** state (add_rsvp_sender) exit executives **/
			FSM_STATE_EXIT_FORCED (7, "add_rsvp_sender", "ip_output_iface_VC1 () [add_rsvp_sender exit execs]")
				{
				}


			/** state (add_rsvp_sender) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "add_rsvp_sender", "idle")
				/*---------------------------------------------------------*/



			/** state (delete_rsvp_sender) enter executives **/
			FSM_STATE_ENTER_FORCED (8, state8_enter_exec, "delete_rsvp_sender", "ip_output_iface_VC1 () [delete_rsvp_sender enter execs]")
				{
				/** Remove a sender from a RSVP queue. WFQ uses RSVP call parameters	**/
				/** (Call_type, Session_ptr and Tspec_ptr). WFQ returns Call_status.	**/
				/** to indicate whether the filter deletion went through.				**/
				
				/* Get the index of the queue to be modified thanks to the TC_handle gotten from		*/
				/* the shared memory. Loop though all the existing queues to find the matching			*/
				/* queue to be modified. If there is no match, the modification will be said to have	*/
				/* failed (Call_status).																*/
				for (q_index = 0; q_index < qm_info->attributes_ptr->no_queues; q_index++)
					{
					/* Compare the queue pointer received from RSVP to an existing queue pointer.	*/
					if ((qm_info->queue_info_ptr[q_index]->pk_list_ptr) ==  ((List*) rsvp_parameters_ptr->tc_handle))
						{
						/* Stops the queue search.	*/
						break;
						}
					}
				
				/* Check if the queue exists. Aborts the RSVP request if not.	*/
				if ((q_index != qm_info->attributes_ptr->no_queues) && (qm_info->rsvp_flag == OPC_TRUE))
					{
					/* Delete the classification scheme for this queue. The classification	*/
					/* parameters are taken from the shared memory. The classification		*/
					/* includes the protocol type, the source and destination IP addresses	*/
					/* and the source and destination port numbers.							*/
				
					/* Get the number of classification schemes.	*/
					number_of_schemes = op_prg_list_size (qm_info->attributes_ptr->classification_list_ptr);
				
					/* Loop through all the classification schemes to find the filter	*/
					/* for the specified queue and sender.								*/
					for (scheme_id = 0; scheme_id < number_of_schemes; scheme_id ++)
						{
						/* Get the classification scheme.	*/
						scheme_ptr = op_prg_list_access (qm_info->attributes_ptr->classification_list_ptr, scheme_id);
				
						/* Check whether this classification scheme matches the request.	*/
						if ((scheme_ptr->queue_id == q_index)
							&& (scheme_ptr->source_port == rsvp_parameters_ptr->sender_ptr->sender_port)
							&& (scheme_ptr->source_address == rsvp_parameters_ptr->sender_ptr->sender_addr))
							{
							break;
							}
						}
				
					/* Check whether the filter to remove exists.	*/
					if (scheme_id == number_of_schemes)
						{
						/* The filter to remove does not exist for this queue since	*/
						/* this queue does not have any filter on this sender.		*/
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the sender deletion failed.								*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
						}
					else
						{
						/* Remove the filter.	*/
						op_prg_list_remove (qm_info->attributes_ptr->classification_list_ptr, scheme_id);
						ip_address_destroy (scheme_ptr->source_address);
						op_prg_mem_free (scheme_ptr);
				
						/* Set the call status field in ICI sent by RSVP to indicate	*/
						/* that the sender deletion succeeded.							*/
						rsvp_parameters_ptr->call_status = OPC_COMPCODE_SUCCESS;
				
						/* Writing traces for ODB.	*/
						if (LTRACE_RSVP)
							{
							op_prg_odb_print_major ("RSVP queue sender removal succeeded", OPC_NIL);
							}
						}
					}
				else
					{
					/* Set the call status field in ICI sent by RSVP to indicate	*/
					/* that the queue creation failed.								*/
					rsvp_parameters_ptr->call_status = OPC_COMPCODE_FAILURE;
				
					/* Writing traces for ODB.	*/
					if (LTRACE_RSVP)
						{
						op_prg_odb_print_major ("RSVP queue sender removal failed", OPC_NIL);
				
						if (qm_info->rsvp_flag == OPC_FALSE)
							{
							op_prg_odb_print_minor ("RSVP is disabled on this interface.", OPC_NIL);
							}
						}
					}
				}


			/** state (delete_rsvp_sender) exit executives **/
			FSM_STATE_EXIT_FORCED (8, "delete_rsvp_sender", "ip_output_iface_VC1 () [delete_rsvp_sender exit execs]")
				{
				}


			/** state (delete_rsvp_sender) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "delete_rsvp_sender", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (3,ip_output_iface_VC1)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
ip_output_iface_VC1_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (ip_output_iface_VC1_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (ip_output_iface_VC1)",
			sizeof (ip_output_iface_VC1_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((ip_output_iface_VC1_state *)(*gen_state_pptr))->current_block = 6;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
ip_output_iface_VC1_diag (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_output_iface_VC1_diag ())

	if (1)
		{
		OmsT_Qm_Prio_Classifier_Func_Ptr		function_ptr;
		int										insert_ok;
		Packet *  								pkptr;
		int										queue_id;
		double									time_to_service;
		Ici *									qos_ici_ptr;
		char									disp_string1 [255];
		char 									disp_string2 [255];
		OmsT_Qm_Pkt_Info 						pkt_info;
		int										q_size;
		char									new_name [200];
		int										q_index;
		int										pk_size;
		double									current_time;
		List *									interface_table_ptr;
		OmsT_Qm_Stat_Info *						stat_info_ptr;
		
		/* Variables defined for Virtual Clock algorithm          */
		double 									v_clock;
		double									a_v_clock = 0;
		double									c_v_clock = 0;
		double									arr_rate;
		double									v_tick = 0;
		double									min;
		int										min_vc_q_index;
		int										no_eqvc_queues;
		int										j;
		int										active_q_index[10];
		Packet *								packetptr;
		double									virtual_clock_stamp;
		double									a_virtual_clock_stamp;
		
		/* Used to determine the mode with which this process got */
		/* interrupted.  Useful in determining transitions from   */
		/* the "idle" state.                                      */
		int										invocation_mode = OPC_INT_UNDEF;
		
		/* Variable used when RSVP is enabled.	*/
		RsvpT_TC_Downcall_Type					rsvp_call_type;
		int										number_of_queues;
		double									weight;
		OmsT_Qm_Queue_Configuration **			new_queue_configuration_ptr;
		OmsT_Qm_Queue_Info **					new_queue_info_ptr;
		OmsT_Qm_Classification_Criteria *		classification_element_ptr;
		int										number_of_schemes;
		int										list_index;
		int										scheme_id;
		OmsT_Qm_Classification_Criteria *		scheme_ptr;
		int										packet_id;
		int										deleted_queue_size;

		/* Diagnostic Block */


		BINIT
		if (is_output_initialized == OPC_FALSE)
			{
			printf ("\t\t**********************************************************************\n");
			printf ("\t\t* The output interface process in this node has not been intialized. *\n");
			printf ("\t\t* Any process has to receive at least its \"BEGSIM\" interrupt         *\n");
			printf ("\t\t* before it can be queried.								          *\n");
			printf ("\t\t**********************************************************************\n");
			}
		else
			{
			if ((LTRACE_QM) || (op_prg_odb_ltrace_active ("red")) || (LTRACE_RSVP))
				{
				output_iface_information_print ();
				}
			}

		/* End of Diagnostic Block */

		}

	FOUT;
	}




void
ip_output_iface_VC1_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_output_iface_VC1_terminate (void))

	if (1)
		{
		OmsT_Qm_Prio_Classifier_Func_Ptr		function_ptr;
		int										insert_ok;
		Packet *  								pkptr;
		int										queue_id;
		double									time_to_service;
		Ici *									qos_ici_ptr;
		char									disp_string1 [255];
		char 									disp_string2 [255];
		OmsT_Qm_Pkt_Info 						pkt_info;
		int										q_size;
		char									new_name [200];
		int										q_index;
		int										pk_size;
		double									current_time;
		List *									interface_table_ptr;
		OmsT_Qm_Stat_Info *						stat_info_ptr;
		
		/* Variables defined for Virtual Clock algorithm          */
		double 									v_clock;
		double									a_v_clock = 0;
		double									c_v_clock = 0;
		double									arr_rate;
		double									v_tick = 0;
		double									min;
		int										min_vc_q_index;
		int										no_eqvc_queues;
		int										j;
		int										active_q_index[10];
		Packet *								packetptr;
		double									virtual_clock_stamp;
		double									a_virtual_clock_stamp;
		
		/* Used to determine the mode with which this process got */
		/* interrupted.  Useful in determining transitions from   */
		/* the "idle" state.                                      */
		int										invocation_mode = OPC_INT_UNDEF;
		
		/* Variable used when RSVP is enabled.	*/
		RsvpT_TC_Downcall_Type					rsvp_call_type;
		int										number_of_queues;
		double									weight;
		OmsT_Qm_Queue_Configuration **			new_queue_configuration_ptr;
		OmsT_Qm_Queue_Info **					new_queue_info_ptr;
		OmsT_Qm_Classification_Criteria *		classification_element_ptr;
		int										number_of_schemes;
		int										list_index;
		int										scheme_id;
		OmsT_Qm_Classification_Criteria *		scheme_ptr;
		int										packet_id;
		int										deleted_queue_size;

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in ip_output_iface_VC1_svar function. */
#undef warning_frag_message_print
#undef warning_pk_dropped_message_printed
#undef shared_mem_ptr
#undef interface_table_size
#undef qm_info
#undef processor_busy
#undef arp_ici_ptr
#undef stat_info_list_ptr
#undef interface_index
#undef queuing_processing_scheme
#undef stat_index
#undef current_byte_count
#undef outstrm
#undef is_output_initialized
#undef interface_info_ptr
#undef rsvp_parameters_ptr
#undef rsvp_allocated_bandwidth_stathandle
#undef rsvp_allocated_buffer_stathandle
#undef rsvp_allocated_buffer
#undef rsvp_allocated_bandwidth
#undef sending_packet_ptr
#undef reservable_buffer_percentage
#undef interface_buffer_size_stathandle
#undef max_reservable_bandwidth_per_flow
#undef max_reservable_bandwidth
#undef queue_to_be_deleted
#undef virtual_clock_stamp_stathandle
#undef a_virtual_clock_stamp_stathandle
#undef service_time_stathandle



void
ip_output_iface_VC1_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	ip_output_iface_VC1_state		*prs_ptr;

	FIN (ip_output_iface_VC1_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (ip_output_iface_VC1_state *)gen_ptr;

	if (strcmp ("warning_frag_message_print" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->warning_frag_message_print);
		FOUT;
		}
	if (strcmp ("warning_pk_dropped_message_printed" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->warning_pk_dropped_message_printed);
		FOUT;
		}
	if (strcmp ("shared_mem_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->shared_mem_ptr);
		FOUT;
		}
	if (strcmp ("interface_table_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->interface_table_size);
		FOUT;
		}
	if (strcmp ("qm_info" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->qm_info);
		FOUT;
		}
	if (strcmp ("processor_busy" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->processor_busy);
		FOUT;
		}
	if (strcmp ("arp_ici_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->arp_ici_ptr);
		FOUT;
		}
	if (strcmp ("stat_info_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->stat_info_list_ptr);
		FOUT;
		}
	if (strcmp ("interface_index" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->interface_index);
		FOUT;
		}
	if (strcmp ("queuing_processing_scheme" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->queuing_processing_scheme);
		FOUT;
		}
	if (strcmp ("stat_index" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->stat_index);
		FOUT;
		}
	if (strcmp ("current_byte_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->current_byte_count);
		FOUT;
		}
	if (strcmp ("outstrm" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->outstrm);
		FOUT;
		}
	if (strcmp ("is_output_initialized" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->is_output_initialized);
		FOUT;
		}
	if (strcmp ("interface_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->interface_info_ptr);
		FOUT;
		}
	if (strcmp ("rsvp_parameters_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_parameters_ptr);
		FOUT;
		}
	if (strcmp ("rsvp_allocated_bandwidth_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_allocated_bandwidth_stathandle);
		FOUT;
		}
	if (strcmp ("rsvp_allocated_buffer_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_allocated_buffer_stathandle);
		FOUT;
		}
	if (strcmp ("rsvp_allocated_buffer" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_allocated_buffer);
		FOUT;
		}
	if (strcmp ("rsvp_allocated_bandwidth" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_allocated_bandwidth);
		FOUT;
		}
	if (strcmp ("sending_packet_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sending_packet_ptr);
		FOUT;
		}
	if (strcmp ("reservable_buffer_percentage" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->reservable_buffer_percentage);
		FOUT;
		}
	if (strcmp ("interface_buffer_size_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->interface_buffer_size_stathandle);
		FOUT;
		}
	if (strcmp ("max_reservable_bandwidth_per_flow" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->max_reservable_bandwidth_per_flow);
		FOUT;
		}
	if (strcmp ("max_reservable_bandwidth" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->max_reservable_bandwidth);
		FOUT;
		}
	if (strcmp ("queue_to_be_deleted" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->queue_to_be_deleted);
		FOUT;
		}
	if (strcmp ("virtual_clock_stamp_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->virtual_clock_stamp_stathandle);
		FOUT;
		}
	if (strcmp ("a_virtual_clock_stamp_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->a_virtual_clock_stamp_stathandle);
		FOUT;
		}
	if (strcmp ("service_time_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->service_time_stathandle);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}
